/*
Module Name:Main.cpp
*****************************************
**  Copyright  (C)  WCH  2001-2018     **
**  Web:  http://wch.cn                **
*****************************************
Environment:
user mode only,VC6.0
Revision History:
01/08/2019: TECH
Descriptor:
WCH MCU ISPDLL ʾ
֧CH56X/CH55X/CH549
*/

#include "resource.h"

#include <stdio.h>
#include "Main.h"

#include "WCH55xISPDLL.h"
#pragma comment(lib,"WCH55xISPDLL")
#include <time.h>

DEFINE_GUID(GUID_DEVINTERFACE_COMPORT,                0x86e0d1e0L, 0x8089, 0x11d0, 0x9c, 0xe4, 0x08, 0x00, 0x3e, 0x30, 0x1f, 0x73);
#define mDnDev_MAX_NUMBER 16
#define     ADAPTER_MAX_NUMBER     4

//ȫֱ
HICON  hIcon;
HWND AfxMainHwnd; //
HINSTANCE AfxMainIns; //ʵ
BOOL AfxIspIsRunning = FALSE;    //أܽ豸ɨ
BOOL AfxIspDevIsChanged = FALSE; //豸Ƿвα仯
BOOL AfxAutoDnAfterPlug = TRUE;  //豸Զ
BOOL IsDownloading,IsDeviceChanged;
Isp55xDevInforS AfxDnDev[MAX_ISPDEV_NUM] = {0}; //ISP豸Ϣ
CH55xIspOptionS AfxIspOption = {0};  //ѡǰ
ULONG AfxDnDevCnt; //ǰ豸
ULONG AfxIspDnCnt = 0,AfxIspDnSuccCnt = 0,AfxIspDnErrCnt = 0;
BOOL AfxAbortSerDeviceWaitIn = FALSE;
ULONG LastSerPortSel;
ULONG AfxNetAdapCnt;//,AfxLocalIP;
NetAdapterInforS AfxNetAdap[ADAPTER_MAX_NUMBER] = {0};
ULONG  uOutFileLen; //IAP,ISPļϲ

//
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
//̼߳
DWORD WINAPI ISPFlashDnThread_CH55xUSB(LPVOID lpParameter);
//豸ӿڣʾ
DWORD WINAPI EnumIspDeviceProc(LPVOID lpParameter);

//Ӧó
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	AfxMainIns = hInstance;
	hIcon = LoadIcon(hInstance,(LPCTSTR)IDI_Main);
	return 	DialogBox(hInstance, (LPCTSTR)IDD_Isp55xApi_DemoDlg, 0, (DLGPROC)WndProc);
	
}

//öٱIP,MACϢڿڡ
ULONG EnumNetAdapter()
{
	PIP_ADAPTER_INFO pAdapterInfo;
	PIP_ADAPTER_INFO pAdapter = NULL;
	DWORD dwRetVal = 0,i=0;
	CHAR temStr[128] = "";
	
	pAdapterInfo = (IP_ADAPTER_INFO *) malloc( sizeof(IP_ADAPTER_INFO) );
	ULONG ulOutBufLen = sizeof(IP_ADAPTER_INFO);
	
	AfxNetAdapCnt = 0;
	for(i=0;i<ADAPTER_MAX_NUMBER;i++)
	{
		ZeroMemory(&AfxNetAdap[i],sizeof(AfxNetAdap[i]));
	}
	
	if (GetAdaptersInfo( pAdapterInfo, &ulOutBufLen) == ERROR_BUFFER_OVERFLOW) {
		free(pAdapterInfo);
		pAdapterInfo = (IP_ADAPTER_INFO *) malloc (ulOutBufLen); 
	}
	
	if ((dwRetVal = GetAdaptersInfo( pAdapterInfo, &ulOutBufLen)) == NO_ERROR) {
		pAdapter = pAdapterInfo;
		while (pAdapter)
		{
			i++;
			{
				AfxNetAdap[AfxNetAdapCnt].wDhcpEnabled = pAdapter->DhcpEnabled;
				AfxNetAdap[AfxNetAdapCnt].dIndex = pAdapter->Index;
				strcpy(AfxNetAdap[AfxNetAdapCnt].szAdapterDescriptor,pAdapter->Description);
				strcpy(AfxNetAdap[AfxNetAdapCnt].szDhcpServer,pAdapter->DhcpServer.IpAddress.String);
				strcpy(AfxNetAdap[AfxNetAdapCnt].szGatewayIP,pAdapter->GatewayList.IpAddress.String);
				strcpy(AfxNetAdap[AfxNetAdapCnt].szMaskIP,pAdapter->IpAddressList.IpMask.String);
				strcpy(AfxNetAdap[AfxNetAdapCnt].szIPAddress,pAdapter->IpAddressList.IpAddress.String);
				strcpy(AfxNetAdap[AfxNetAdapCnt].szMacAddress,MacHexToStrA(pAdapter->Address)); 				
				AfxNetAdap[AfxNetAdapCnt].wType = pAdapter->Type;
				AfxNetAdap[AfxNetAdapCnt].dwIPAddress = inet_addr(AfxNetAdap[AfxNetAdapCnt].szIPAddress);
			}
			AfxNetAdapCnt++;
			pAdapter = pAdapter->Next;			
		}
	}
	else
	{
		//DbgPrint("Call to GetAdaptersInfo failed.");
	}
	return AfxNetAdapCnt;
}


VOID CALLBACK CH55X_USB_NOTIFY_ROUTINE(  // 豸¼֪ͨص
									   ULONG			iEventStatus, //Ƴ¼
									   ULONG           DevIndex, //λʾλ0Ϊ10豸Դ
									   ULONG           DevCnt)   //ǰ豸
{
	ULONG i;
	
	AfxDnDevCnt = DevCnt;
	
	if( AfxIspIsRunning ) //أܽ豸ɨ,ɨ
		AfxIspDevIsChanged = TRUE;
	else
	{
		//ö豸
		EnumIspDeviceProc(NULL);
		//豸ʼس
		if( (AfxAutoDnAfterPlug ) && (iEventStatus == CH375_DEVICE_ARRIVAL) )
		{
			for(i=0;i<16;i++) //ÿ豸
			{
				if( ((DevIndex>>i)&0x01) )
				{
					//ָѡ豸
					SendDlgItemMessage(AfxMainHwnd,IDC_DeviceList,CB_SETCURSEL,i,0);					
					//ʼ
					ISPFlashDnThread_CH55xUSB((PVOID)i); //̼
				}
			}			
		}
	}	
}

//ʮַתʮ,תַltoa()
ULONG mTStrToHEX(PTCHAR str) 
{  
	char mlen,i=0;
	UCHAR iChar=0,Char[18]="";
	UINT mBCD=0,de=1;
	
	if( sizeof(TCHAR) == 2 )
	{
		sprintf((PCHAR)&Char[0],"%s\0",str);
		mlen = (CHAR)strlen((PCHAR)Char);
	}
	else
	{
		mlen = (CHAR)_tcslen(str);
		memcpy(Char,str,mlen);
	}
	for(i=mlen-1;i>=0;i--)
	{	
		iChar=Char[i];
		if ( iChar >= '0' && iChar <= '9' )
			mBCD = mBCD+(iChar -'0')*de;
		else if ( iChar >= 'A' && iChar <= 'F' ) 
			mBCD =mBCD+ (iChar - 'A' + 0x0a)*de;
		else if ( iChar >= 'a' && iChar <= 'f' )
			mBCD =mBCD+ (iChar - 'a' + 0x0a)*de;
		else return(0);
		de*=16;
	}
	return(mBCD);
}
//ǰISPѡ
BOOL CH55x_SetIspOption()
{
	CHAR TemBuf[64] = "";
	CHAR FileName[MAX_PATH] = "";	
	CH55xIspOptionS IspOption = {0};
	BOOL RetVal = FALSE;
	
	//豸
	IspOption.IspMcuType = (UCHAR)SendDlgItemMessage(AfxMainHwnd,IDC_ChipType,CB_GETCURSEL,0,0);
	IspOption.IspMcuSeries = (UCHAR)SendDlgItemMessage(AfxMainHwnd,IDC_ChipSeries,CB_GETCURSEL,0,0);
	if( IspOption.IspMcuSeries == 0)
	{
		if( IspOption.IspMcuType < 2 )
			IspOption.IspMcuType += 0x51;
		else if(IspOption.IspMcuType == 2)
			IspOption.IspMcuType = 0x54;
		else
			IspOption.IspMcuType += 0x55;
	}	
	else if(IspOption.IspMcuSeries == 1)
	{
		if(IspOption.IspMcuType == 0)
			IspOption.IspMcuType = 0x61;
		else if(IspOption.IspMcuType == 1)
			IspOption.IspMcuType = 0x63;
		else if(IspOption.IspMcuType == 2)
			IspOption.IspMcuType = 0x65;
		else if(IspOption.IspMcuType == 3)
			IspOption.IspMcuType = 0x66;
		else if(IspOption.IspMcuType == 4)
			IspOption.IspMcuType = 0x67;
		else if(IspOption.IspMcuType == 5)
			IspOption.IspMcuType = 0x68;
	}
	else if(IspOption.IspMcuSeries == 2)
	{
		if(IspOption.IspMcuType == 0)
			IspOption.IspMcuType = 0x46;
		else if(IspOption.IspMcuType == 1)
			IspOption.IspMcuType = 0x47;
		else if(IspOption.IspMcuType == 2)
			IspOption.IspMcuType = 0x48;
		else if(IspOption.IspMcuType == 3)
			IspOption.IspMcuType = 0x49;
	}
	else if(IspOption.IspMcuSeries == 3)
	{
		if(IspOption.IspMcuType == 0)
			IspOption.IspMcuType = 0x71;
		else if(IspOption.IspMcuType == 1)
			IspOption.IspMcuType = 0x73;
		else if(IspOption.IspMcuType == 2)
			IspOption.IspMcuType = 0x77;
		else if(IspOption.IspMcuType == 3)
			IspOption.IspMcuType = 0x78;
		else if(IspOption.IspMcuType == 4)
			IspOption.IspMcuType = 0x79;
	}
	else if(IspOption.IspMcuSeries == 4)
	{
		IspOption.IspMcuType = 0x3F;
	}
	else if(IspOption.IspMcuSeries == 5)
	{
		IspOption.IspMcuType = 0x3F;
	}
	//ؽӿ
	IspOption.IspInterface = SendDlgItemMessage(AfxMainHwnd,IDC_DnInterface,CB_GETCURSEL,0,0);
	//ɺǷλֱĿ
	IspOption.IsMcuResetAfterIsp = (IsDlgButtonChecked(AfxMainHwnd,IDC_ResetAfterIsp) == BST_CHECKED);  		
	//ʹϵ縴λڼĶʱλ
	IspOption.IsEnableLongRest = (IsDlgButtonChecked(AfxMainHwnd,IDC_LONG_RESET) == BST_CHECKED);    	
	//ָֹλ
	IspOption.IsEnableResetPin = (IsDlgButtonChecked(AfxMainHwnd,IDC_P5_RESET) == BST_CHECKED);
	//þǿ,CH554֧
	IspOption.IsXtOscStrong = (IsDlgButtonChecked(AfxMainHwnd,IDC_OSC_STRONG) == BST_CHECKED);        
	//ʹϵͳλڼP0˿ڵڲ,CH554֧
	IspOption.IsEnableP0PullUp = (IsDlgButtonChecked(AfxMainHwnd,IDC_P0_PULLUP) == BST_CHECKED);   
	//ǷIAP
	IspOption.IsEnableIAP = FALSE;
	//IAPʼַ
	GetDlgItemText(AfxMainHwnd,IDC_EDIT_IAP_ADDR,TemBuf,sizeof(TemBuf));
	IspOption.IAPStartAddr = mStrToHEX(TemBuf);
	//IAPļ
	GetDlgItemText(AfxMainHwnd,IDC_IapDnFile,IspOption.IapFileName,sizeof(IspOption.IapFileName));		
	//ûļ
	GetDlgItemText(AfxMainHwnd,IDC_UserDnFile,IspOption.UserFileName,sizeof(IspOption.UserFileName));	
	//豸֪ͨ
	IspOption.IsEnableUsbPnpNotify = (IsDlgButtonChecked(AfxMainHwnd,IDC_EnableUsbPnpNotify) == BST_CHECKED); 
    //Ĭؽ
	IspOption.BootPinNum = (IsDlgButtonChecked(AfxMainHwnd,IDC_BootP1) == BST_CHECKED); 
	//ⰴ
	IspOption.IsNoKeyDnAtSer = (IsDlgButtonChecked(AfxMainHwnd,IDC_AutoIspNoKeySel) == BST_CHECKED);
    //DataFlash
	IspOption.IsClearDataFlash = (IsDlgButtonChecked(AfxMainHwnd,IDC_IsClearDataFlash) == BST_CHECKED);
	//BOOT뿪
	IspOption.IsBootLoader = 1;
	//д
	IspOption.IsCodeProtect = (IsDlgButtonChecked(AfxMainHwnd,IDC_CHECK_PROTECT) == BST_CHECKED);
	//
	IspOption.IsEnableCfgBuf64K = (IsDlgButtonChecked(AfxMainHwnd,IDC_CH56x_CodeBuf64K) == BST_CHECKED);
	IspOption.EnableIce = (IsDlgButtonChecked(AfxMainHwnd,IDC_CH56x_EnableIce) == BST_CHECKED);	
	IspOption.IsSetDevIP = (IsDlgButtonChecked(AfxMainHwnd,IDC_CH56x_SetDnDevMac) == BST_CHECKED);
	IspOption.LV_RST_VOL = (UCHAR)SendDlgItemMessage(AfxMainHwnd,IDC_COMBO_LIMITV,CB_GETCURSEL,0,0);
	//ʹUSBDģʽ
	IspOption.IsUsbdMode = (IsDlgButtonChecked(AfxMainHwnd,IDC_USBD_MODE_32F) == BST_CHECKED);
	//ʹֹͣģʽ͹ĸλ
	IspOption.IsStopRst = (IsDlgButtonChecked(AfxMainHwnd,IDC_STOP_RST_32F) == BST_CHECKED);
	//ʹܴģʽ͹ĸλ
	IspOption.IsStandbyRst = (IsDlgButtonChecked(AfxMainHwnd,IDC_STANDBY_RST_32F) == BST_CHECKED);
	//ʹUSBDڲ
	IspOption.IsUsbdPu = (IsDlgButtonChecked(AfxMainHwnd,IDC_USPD_PU_32F) == BST_CHECKED);
	//ʹӲIWDG
	IspOption.IsIwdgSw = (IsDlgButtonChecked(AfxMainHwnd,IDC_IWDG_SW_32F) == BST_CHECKED);
	IspOption.IsEraseAllCFlash = TRUE;
	IspOption.IsMcuResetAfterIsp = 0;

	//ôڲʣֻCH571/3Ч
	if(SendDlgItemMessage(AfxMainHwnd,IDC_COMBO_BAUD,CB_GETCURSEL,0,0)==1)
	{
		IspOption.Baud[0] = 0x40;
		IspOption.Baud[1] = 0x42;
		IspOption.Baud[2] = 0x0F;
		IspOption.Baud[3] = 0x00;
	}
	else if(SendDlgItemMessage(AfxMainHwnd,IDC_COMBO_BAUD,CB_GETCURSEL,0,0)==2)
	{
		IspOption.Baud[0] = 0x80;
		IspOption.Baud[1] = 0x84;
		IspOption.Baud[2] = 0x1E;
		IspOption.Baud[3] = 0x00;
	}
	else
	{
		IspOption.Baud[0] = 0x00;
		IspOption.Baud[1] = 0xC2;
		IspOption.Baud[2] = 0x01;
		IspOption.Baud[3] = 0x00;
	}
	
	//ȡWPR
	char  szBuf[20] = "";
	memset(szBuf,0,20);
	GetDlgItemText(AfxMainHwnd,IDC_EDIT_CH32F_D0,szBuf,sizeof(szBuf));
	IspOption.WPR_DATA[0] = (UCHAR) mTStrToHEX(szBuf);
	
	memset(szBuf,0,20);
	GetDlgItemText(AfxMainHwnd,IDC_EDIT_CH32F_D1,szBuf,sizeof(szBuf));
	IspOption.WPR_DATA[2] = (UCHAR) mTStrToHEX(szBuf);
	
	memset(szBuf,0,20);
	GetDlgItemText(AfxMainHwnd,IDC_EDIT_CH32F_WRP0,szBuf,sizeof(szBuf));
	IspOption.WPR_DATA[4] = (UCHAR) mTStrToHEX(szBuf);
	
	memset(szBuf,0,20);
	GetDlgItemText(AfxMainHwnd,IDC_EDIT_CH32F_WRP1,szBuf,sizeof(szBuf));
	IspOption.WPR_DATA[5] = (UCHAR) mTStrToHEX(szBuf);
	
	memset(szBuf,0,20);
	GetDlgItemText(AfxMainHwnd,IDC_EDIT_CH32F_WRP2,szBuf,sizeof(szBuf));
	IspOption.WPR_DATA[6] = (UCHAR) mTStrToHEX(szBuf);
	
	memset(szBuf,0,20);
	GetDlgItemText(AfxMainHwnd,IDC_EDIT_CH32F_WRP3,szBuf,sizeof(szBuf));
	IspOption.WPR_DATA[7] = (UCHAR) mTStrToHEX(szBuf);
	
	if( IspOption.IsSetDevIP )
	{	
		GetDlgItemText(AfxMainHwnd,IDC_IspDevSetIP,TemBuf,sizeof(TemBuf));
		IspOption.dwDevIP = inet_addr(TemBuf);		
	}	
	//CH554-CH551֧
	if( IspOption.IspMcuSeries == 0 && IspOption.IspMcuType <= 3 )
	{
		//þǿ,CH554֧
		IspOption.IsXtOscStrong = FALSE; 
		//ʹϵͳλڼP0˿ڵڲ,CH554֧
		IspOption.IsEnableP0PullUp = FALSE;    
		
		IspOption.IsFirstRunIAP = FALSE;
		IspOption.IsEnableIAP = FALSE;		
	}
	if(IspOption.IspInterface == 2)
	{
		ULONG i;
		
		i = SendDlgItemMessage(AfxMainHwnd,IDC_LocalAdapList,CB_GETCURSEL,0,0);
		if( i == CB_ERR )
		{
			DbgPrint("Invalid mac addr.");
			return FALSE;
		}		
		IspOption.LocalIP = inet_addr(AfxNetAdap[i].szIPAddress);
		IspOption.GatewayIP = inet_addr(AfxNetAdap[i].szGatewayIP);
		IspOption.MaskIP = inet_addr(AfxNetAdap[i].szMaskIP);
		
		i = SendDlgItemMessage(AfxMainHwnd,IDC_DeviceList,CB_GETCURSEL,0,0);
		if( i != CB_ERR )
			memcpy(IspOption.NetDevMacAddr,AfxDnDev[i].MacAddr,6);
	}
	
	if( IspOption.IspInterface == 1 ) //ز֧²
	{
		IspOption.IsEnableUsbPnpNotify = FALSE; //
	}
	
	if( IspOption.IsEnableUsbPnpNotify )//豸֪ͦͨ
	{
		IspOption.UsbPnpNotifyRoutine = CH55X_USB_NOTIFY_ROUTINE; //豸ʱô˺
	}
	else
	{			
		IspOption.UsbPnpNotifyRoutine = NULL; //ȡ豸μ
	}	
	
	if( WCH55x_SetIspOption(&IspOption) ) //isp	
	{
		memcpy(&AfxIspOption,&IspOption,sizeof(IspOption));
		RetVal = TRUE;
	}
	else
	{
		ZeroMemory(&AfxIspOption,sizeof(AfxIspOption));
	}
	AfxAutoDnAfterPlug = (IsDlgButtonChecked(AfxMainHwnd,IDC_AutoDnAfterPlug) == BST_CHECKED); //豸ǷԶ
	
		
	return RetVal;
	
}

///////////////////////////////////IAP,ISPļϲغ////////////////////////////////////////////
BOOL CharToHex(char* pInChar,UCHAR* pOutChar)
{
	char h,l;	
	h = pInChar[0]; //4λ
	l = pInChar[1]; //4λ
	if(l>='0' && l<='9')
	{
		l = l - '0';	
	}
	else if(l>='a' && l<='f')
	{
		l = l - 'a' + 0xa;
	}
	else if(l>='A' && l<='F')
	{
		l = l - 'A' + 0xa;
	}
	else
	{	
		return FALSE;
	}	
	if(h>='0' && h<='9')
	{
		h = h - '0';
	}
	else if(h>='a' && h<='f')
	{
		h = h - 'a' + 0xa;
	}
	else if(h>='A' &&h <='F')
	{
		h = h - 'A' + 0xa;
	}
	else
	{
		return FALSE;
	}	
	h <<= 4;
	h |= l;
	*pOutChar = h;
	return TRUE;
}


BOOL HexToBin( PVOID Hexbuf, ULONG iHexBufLen, PVOID Binbuf, PULONG iBinLen )
{
	PUCHAR hp;              // ݴHexbufָ
	ULONG StartPos;         // ¼ڿʼλ
	UCHAR DataBuf[256];     // ʱݴŻ
	USHORT ExtAdr;          // չַ
	USHORT SegAdr;          // չεַ
	USHORT OfsAdr;          // ƫƵַ
	ULONG WriteAdr,StartAddr=0;         // дַ
	BOOL   bIsFirst=TRUE;
	ULONG   uStrOff;

	__try
	{						// 0X00
		memset( Binbuf, 0x00, iHexBufLen);
	}
	__except( EXCEPTION_EXECUTE_HANDLER )
	{
		return FALSE;   // ʷ쳣,תʧ
	}
	// HEXļǷɶ
	if( IsBadReadPtr( Hexbuf, iHexBufLen ) )
		return FALSE;
	
	StartPos = 0;
	ExtAdr = 0;
	SegAdr = 0;
	hp = (PUCHAR)Hexbuf;   //ݴHEXʼָ
	*iBinLen = 0; 

	//LINE ݸʽ0x3A(1ֽ) + ݳ(2ֽ) + ƫַַ(4ֽ) + (1ֽ) + (2ֽΪλ) + (2ֽ) + 0x0D + 0x0A

	while( 1 )
	{
		if( (StartPos + 2) > iHexBufLen ) //ݵٵð3ֽ //if( (StartPos + 2) > iHexBufLen ) //ݵٵð3ֽ
			return FALSE;
		
		//ȡͷ־0x3A
		if( hp[StartPos] == ':' )
		{
			UCHAR i;
			ULONG Len = 0;          // Чݳ
			UCHAR CheckSum;         // У		

			//ȡHEXеݳ,2ֽ
			CharToHex((char*)(hp + StartPos + 1),(PUCHAR)&Len); 
		//	if( (StartPos + Len*2 + 13) > iHexBufLen ) //һHEXݳ13ֽ
		//		return FALSE;                          //ֹǷڴ

			//LINE OFFSET3-4-5-6:ʼַ4ֽ
			//LINE OFFSET7...,2ı			
			for( CheckSum=(UCHAR)Len, i=0; i < (Len+4); ++i ) //־ͷͼֵ֮ӣۼӺӣΪ0x100ͳ
			{// ת
				CharToHex((char *)(hp+StartPos+3+i+i),(PUCHAR)(DataBuf+i)); //DataBufŴʼַʼתֵ
				CheckSum += DataBuf[i];
			}
			if( CheckSum != 0 )   // Уʧ,HEXļ
				return FALSE;

			//ͷ
			switch ( DataBuf[2] ) 
			{
			case  0: // ݼ¼
				{
					OfsAdr = DataBuf[0]*256 + DataBuf[1];
					WriteAdr = ExtAdr*65536 + SegAdr*16 + OfsAdr;	
					
					if(bIsFirst)
					{
						uStrOff = WriteAdr;
						bIsFirst = FALSE;
					}
					if(WriteAdr>=0x08000000)
		 				WriteAdr -= uStrOff;
			/*		{
						CHAR FmtStr[128] = "";
						sprintf(FmtStr,"0x%08X",StartAddr);
						SetDlgItemText(AfxMainHwnd,IDC_HexStartAddr,FmtStr);	
					}  */
					if(OfsAdr == 0)
					{
						memcpy(&(((PUCHAR)Binbuf)[WriteAdr]),&DataBuf[3],Len);
					}
					else
					{
						if( WriteAdr <= StartAddr )
						{
							return FALSE;	
						}
						WriteAdr -= StartAddr;
						memcpy(&(((PUCHAR)Binbuf)[WriteAdr]),&DataBuf[3],Len);
					}
					
					memcpy(&(((PUCHAR)Binbuf)[WriteAdr]),&DataBuf[3],Len);
					StartPos += Len*2 + 13;         // һеĿʼ

					if( (WriteAdr + Len) > *iBinLen )
						*iBinLen = WriteAdr + Len;  // õַ
				}
				break;				
			case  2: // չεַ¼
				{
					SegAdr = DataBuf[3]*256 + DataBuf[4];
					StartPos += 17;
				}
				break;				
			case  4: // չԵַ¼
				{
					ExtAdr = DataBuf[3]*256 + DataBuf[4];
					StartPos += 17;
				}
				break;				
			case 5:  //ʼԵַ¼
				{
					StartPos += 21;
				}
				break;				
			case 3: //ʼεַ¼
				{
					StartPos += 21;
				}
				break;				
			case  1:  // HEXļ־
				StartAddr -= 4;
				return TRUE;				
			default:
				return FALSE;
			}
		}
		else
		{
			return FALSE;                 // ܳ
		}
	}
}

//IAP HEXļʼַ
BOOL GetIapStartAddrFromHex( PVOID Hexbuf, ULONG iHexBufLen,ULONG *IapStartAddr,BOOL IsC51)
{
	PUCHAR hp;              // ݴHexbufָ
	ULONG StartPos;         // ¼ڿʼλ
	UCHAR DataBuf[256];     // ʱݴŻ
	USHORT ExtAdr;          // չַ
	USHORT SegAdr;          // εַ
	USHORT OfsAdr;          // ƫƵַ
	ULONG WriteAdr;         // дַ
	
	*IapStartAddr = 0;

	// HEXļǷɶ
	if( IsBadReadPtr( Hexbuf, iHexBufLen ) )
		return FALSE;
	
	StartPos = 0;
	ExtAdr = 0;
	SegAdr = 0;
	hp = (PUCHAR)Hexbuf;        // ݴHEXʼָ
	while( 1 )
	{
		if( (StartPos + 2) > iHexBufLen )
			return FALSE;
		if( hp[StartPos] == ':' )
		{
			UCHAR i;
			ULONG Len = 0;              // Чݳ
			UCHAR CheckSum;         // У		
			CharToHex((char*)(hp + StartPos + 1),(UCHAR*)&Len);
			if( (StartPos + Len*2 + 13) > iHexBufLen )
				return FALSE;                   // ֹǷڴ
			
			for( CheckSum=(UCHAR)Len, i=0; i < (Len+4); ++i )
			{                                   // ת
				CharToHex((char *)(hp+StartPos+3+i+i),(UCHAR*)(DataBuf+i));
				CheckSum += DataBuf[i];
			}
			if( CheckSum != 0 )                 // Уʧ,HEXļ
				return FALSE;

			switch ( DataBuf[2] )
			{
			case  0:
				{
					OfsAdr = DataBuf[0]*256 + DataBuf[1];
					WriteAdr = ExtAdr*65536 + SegAdr*16 + OfsAdr;
					if( *IapStartAddr == 0 )
						*IapStartAddr = WriteAdr;
					else if( ( *IapStartAddr > WriteAdr ) && (WriteAdr>0) )
						*IapStartAddr = WriteAdr;
					
					StartPos += Len*2 + 13;         // һڵĿʼ
				}
				break;
				
			case  2:
				{
					SegAdr = DataBuf[3]*256 + DataBuf[4];
					StartPos += 17;
				}
				break;
				
			case  4:
				{
					ExtAdr = DataBuf[3]*256 + DataBuf[4];
					StartPos += 17;
				}
				break;
				
			case 5:
				{
					StartPos += 21;
				}
				break;
				
			case 3:
				{
					StartPos += 21;
				}
				break;
				
			case  1:                            // HEXļ־
				{
					if(IsC51)
						*IapStartAddr -= 4;
			
				}
				return TRUE;
				
			default:
				return FALSE;
			}
		}
		else
		{
			return FALSE;                 // ܳ
		}
	}
	return FALSE;
}

BOOL IAPHexToBin( PVOID Hexbuf, ULONG iHexBufLen, ULONG *Addr,PVOID Binbuf, PULONG iBinLen,BOOL IsC51)
{
	PUCHAR hp;              // ݴHexbufָ
	ULONG StartPos;         // ¼ڿʼλ
	UCHAR DataBuf[256];     // ʱݴŻ
	USHORT ExtAdr;          // չַ
	USHORT SegAdr;          // εַ
	USHORT OfsAdr;          // ƫƵַ
	ULONG WriteAdr;         // дַ
	ULONG IapStartAddr = 0;
	__try
	{					
		memset( Binbuf, 0, *iBinLen);
	}
	__except( EXCEPTION_EXECUTE_HANDLER )
	{
		return FALSE;   // ʷ쳣,תʧ
	}
	// HEXļǷɶ
	if( IsBadReadPtr( Hexbuf, iHexBufLen ) )
		return FALSE;
	if(IsC51)
	{
		if( GetIapStartAddrFromHex(Hexbuf,iHexBufLen,&IapStartAddr,TRUE) )
		{
			if( IapStartAddr )
				*Addr = IapStartAddr;
		}
	}
	else
	{
		if( GetIapStartAddrFromHex(Hexbuf,iHexBufLen,&IapStartAddr,FALSE) )
		{
			if( IapStartAddr )
				*Addr = IapStartAddr;
		}
	}
	

	StartPos = 0;
	ExtAdr = 0;
	SegAdr = 0;
	hp = (PUCHAR)Hexbuf;        // ݴHEXʼָ
	*iBinLen = 0;

	while( 1 )
	{
		if( (StartPos + 2) > iHexBufLen )
			return FALSE;
		if( hp[StartPos] == ':' )
		{
			UCHAR i;
			ULONG Len = 0;              // Чݳ
			UCHAR CheckSum;         // У		
			CharToHex((char*)(hp + StartPos + 1),(UCHAR*)&Len);
			if( (StartPos + Len*2 + 13) > iHexBufLen )
				return FALSE;                   // ֹǷڴ
			
			for( CheckSum=(UCHAR)Len, i=0; i < (Len+4); ++i )
			{                                   // ת
				CharToHex((char *)(hp+StartPos+3+i+i),(UCHAR*)(DataBuf+i));
				CheckSum += DataBuf[i];
			}
			if( CheckSum != 0 )                 // Уʧ,HEXļ
				return FALSE;

			switch ( DataBuf[2] )
			{
			case  0:
				{
					OfsAdr = DataBuf[0]*256 + DataBuf[1];
					WriteAdr = ExtAdr*65536 + SegAdr*16 + OfsAdr;
					if(!IsC51)
					{
						if( IapStartAddr == 0 )
						{
							IapStartAddr = WriteAdr;
						}

						memcpy(&(((PUCHAR)Binbuf)[WriteAdr]),&DataBuf[3],Len);
					}
					else
					{
						if(OfsAdr == 0)
						{
							memcpy(&(((PUCHAR)Binbuf)[WriteAdr]),&DataBuf[3],Len);
						}
						else
						{
							if( WriteAdr <= *Addr ) return FALSE;	
							WriteAdr -= *Addr;
							memcpy(&(((PUCHAR)Binbuf)[WriteAdr]),&DataBuf[3],Len);
						}
					}
					StartPos += Len*2 + 13;         // һеĿʼ

					if( (WriteAdr + Len) > *iBinLen )
						*iBinLen = WriteAdr + Len;  // õַ
				}
				break;
				
			case  2:
				{
					SegAdr = DataBuf[3]*256 + DataBuf[4];
					StartPos += 17;
				}
				break;
				
			case  4:
				{
					ExtAdr = DataBuf[3]*256 + DataBuf[4];
					StartPos += 17;
				}
				break;
				
			case 5:
				{
					StartPos += 21;
				}
				break;
				
			case 3:
				{
					StartPos += 21;
				}
				break;
				
			case  1:                            // HEXļ־
				{
				}
				return TRUE;
				
			default:
				return FALSE;
			}
		}
		else
		{
			return FALSE;                 // ܳ
		}
	}
	return FALSE;
}
//IAP,ISPƴӺ
UCHAR* MergeFile()
{
	CHAR          szIspPath[MAX_PATH]="",szIapPath[MAX_PATH]="";  //IAP,ISPļ·
	ULONG         uFileLen,uReadLen,Hex2Binlen,Hex2BinlenB;       //ļ
	HANDLE        hFile;                                          //ļ
	UCHAR         *pIspData,*pIapData;                            //ļ
	ULONG         Addr;                                           //תַ
	ULONG         uMaxFlashSize;                                  //оƬFlashС
	TCHAR         FmtStr[258]=_T("");                             //ַ
	UCHAR         *pTransData,*pTransDataB;                       //תָ
	UCHAR         *pMergedFile;                                   //ָ
	//ʼ
	hFile = INVALID_HANDLE_VALUE; 
	uOutFileLen = 0;
	uReadLen = 0;
	Hex2Binlen = 0;
	Hex2BinlenB = 0;
	uMaxFlashSize = 0;
	pIspData = NULL;
	pIapData = NULL;
	pTransData = NULL;
	pTransDataB = NULL;
	pMergedFile = NULL;
	Addr = 0;
	//ݲͬͺŸֵ
	switch(AfxIspOption.IspMcuType)
	{
	case 0x51:
		uMaxFlashSize = 10240;
		break;
	case 0x52:
		uMaxFlashSize = 14336;
		break;
	case 0x54:
		uMaxFlashSize = 14336;
		break;
	case 0x58:
		uMaxFlashSize = 32768;
		break;
	case 0x59:
		uMaxFlashSize = 61440;
		break;
	case 0x61:
		uMaxFlashSize = 65536;
		break;
	case 0x63:
		uMaxFlashSize = 229376;
		break;
	case 0x65:
		uMaxFlashSize = 49512;
		break;
	case 0x66:
		uMaxFlashSize = 65536;
		break;
	case 0x67:
		uMaxFlashSize = 196608;
		break;
	case 0x68:
		uMaxFlashSize = 196608;
		break;
	case 0x46:
		uMaxFlashSize = 32768;
		break;
	case 0x47:
		uMaxFlashSize = 61440;
		break;
	case 0x48:
		uMaxFlashSize = 32768;
		break;
	case 0x49:
		uMaxFlashSize = 61440;
		break;
	case 0x77:
		uMaxFlashSize = 131072;
		break;
	case 0x78:
		uMaxFlashSize = 163840;
		break;
	case 0x79:
		uMaxFlashSize = 256000;
		break;
	case 0x3F:
		uMaxFlashSize = 65536;
		break;
	default:
		uMaxFlashSize = 61440;
		break;
	}
	//IAP
	if(IsDlgButtonChecked(AfxMainHwnd,IDC_CHECK_START_IAP) == BST_CHECKED)        
	{
		GetDlgItemText(AfxMainHwnd,IDC_IapDnFile,szIapPath,sizeof(szIapPath));	
		//IAPļ
		hFile = CreateFile(szIapPath,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		
		if(!hFile)
		{
			DbgPrint("IAPļʧ!");
			pMergedFile = NULL;
			goto _END;
		}
		//ȡIAPļ
		uFileLen = GetFileSize(hFile,NULL);
		
		if(!uFileLen)
		{
			DbgPrint("ЧIAPļ!");
			pMergedFile = NULL;
			goto _END;
		}
		pIapData = new UCHAR[uFileLen+1];
		memset(pIapData,0,uFileLen);
        //ȡIAPļ
		ReadFile(hFile,pIapData,uFileLen,&uReadLen,NULL);
		
		if(!uReadLen)
		{
			DbgPrint("IAPļȡʧ!");
			pMergedFile = NULL;
			goto _END;
		}
		pTransData = new UCHAR[uMaxFlashSize];
		memset(pTransData,0,uMaxFlashSize);
		
		Hex2Binlen = uFileLen;
		
		//жǲHEXļҪתBINļŵbuffer
		if (strstr(szIapPath,".hex") || strstr(szIapPath,".HEX"))          
		{
			//תַHEXļõ
			if(AfxIspOption.IspMcuSeries == 3)  //CH57X
			{
				if (!IAPHexToBin(pIapData, uFileLen,(PULONG)&Addr, pTransData, &Hex2Binlen,FALSE)) 
				{
					DbgPrint("ļ");
					pMergedFile = NULL;
					goto _END;
				}
			}
			else
			{
				if (!IAPHexToBin(pIapData, uFileLen,(PULONG)&Addr, pTransData, &Hex2Binlen,TRUE)) 
				{
					DbgPrint("ļ");
					pMergedFile = NULL;
					goto _END;
				}
			}
			memset(FmtStr,0,sizeof(FmtStr));
			sprintf(FmtStr,"%x",Addr);
			SetDlgItemText(AfxMainHwnd,IDC_EDIT_IAP_ADDR,FmtStr);
			uOutFileLen = Hex2Binlen+Addr;                  //HEXת󷵻ƴӵЧַƫƵַΪļ
		}
		else                                                //BINļתֱӷŵbuffer,ҪǰֽڸƵתַ
		{
			memcpy(pTransData,pIapData,uFileLen);
			uOutFileLen = uFileLen;                        //IAPأϳļΪIAP  .BINļ
			
			GetDlgItemText(AfxMainHwnd,IDC_EDIT_IAP_ADDR,FmtStr,MAX_PATH);
			
			Addr = mTStrToHEX(FmtStr);					   //תַӽȡ
			if(Addr==0 ||(Addr+4)>=uMaxFlashSize)
			{
				DbgPrint("IAP תַЧ!");
				return NULL;
			}
			if(AfxIspOption.IspMcuSeries != 3)  //CH57X
				memcpy(&pTransData[Addr],&pTransData[0],4);    //ǰֽڸƵתַ
			if(uOutFileLen<Addr)
				uOutFileLen += Addr;
		}
		pMergedFile = new UCHAR[uOutFileLen+1];
		memset(pMergedFile,0,uOutFileLen+1);
		if(strstr(szIapPath,".hex") || strstr(szIapPath,".HEX"))
		{
			memcpy(&pMergedFile[Addr],pTransData,Hex2Binlen);
		}
		else
		{
			memcpy(&pMergedFile[0],pTransData,uOutFileLen);
		}
		
	}
	//жiapļСǷ񳬹ǰоƬFlashС
	if(uMaxFlashSize < uOutFileLen)
	{
		DbgPrint("ƫֵѡʵIAPļ!");
		pMergedFile = NULL;
		goto _END;
	}
	{
		GetDlgItemText(AfxMainHwnd,IDC_UserDnFile,szIspPath,sizeof(szIspPath));
		
		if(hFile!=INVALID_HANDLE_VALUE)
			CloseHandle(hFile);
		hFile = CreateFile(szIspPath,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		
		if(!hFile)
		{
			DbgPrint("ISPļʧ!");
			pMergedFile = NULL;
			goto _END;
		}
		//ȡISPļ
		uFileLen =0;
		uFileLen = GetFileSize(hFile,NULL);
		if(!uFileLen)
		{
			DbgPrint("ЧISPļ!");
			pMergedFile = NULL;
			goto _END;
		}
		pIspData = new UCHAR[uFileLen+1];
		memset(pIspData,0,uFileLen);
		//ȡISPļ
		uReadLen = 0;
		ReadFile(hFile,pIspData,uFileLen,&uReadLen,NULL);
		if(!uReadLen)
		{
			DbgPrint("ISPļȡʧ!");
			pMergedFile = NULL;
			uFileLen = GetLastError();
			goto _END;
		}
		
		pTransDataB = new UCHAR[uFileLen+1];
		memset(pTransDataB,0,uFileLen+1);
		
		Hex2BinlenB = uFileLen;
		
		//жǲHEXļҪתBINļŵbuffer
		if (strstr(szIspPath,".hex") || strstr(szIspPath,".HEX"))  
		{
			if (!HexToBin(pIspData, uFileLen, pTransDataB, &Hex2BinlenB)) 
			{
				DbgPrint("ЧISPļ!");
				goto _END;
			}
			if(uOutFileLen==0 && pMergedFile==NULL)                 //ֻISP,ϳļΪISP  .BINļ
			{
				uOutFileLen = Hex2BinlenB;
				pMergedFile = new UCHAR[uOutFileLen+1];
				memset(pMergedFile,0,uOutFileLen+1);
				memcpy(pMergedFile,pTransDataB,uOutFileLen);
			}
			else
			{
				memcpy(pMergedFile,pTransDataB,Hex2BinlenB);        //IAPأISP.binļƵϲļͷλ
			}
		}
		else                                                        //BINļתֱӷŵbuffer
		{
			memcpy(pTransDataB,pIspData,uFileLen);
			if(uOutFileLen==0 && pMergedFile==NULL)
			{
				uOutFileLen = uFileLen;                             //ֻISP,ϳļΪISP.BINļ
				pMergedFile = new UCHAR[uOutFileLen+1];
				memset(pMergedFile,0,uOutFileLen+1);
				memcpy(pMergedFile,pTransDataB,uOutFileLen);
			}
			else
			{
				memcpy(pMergedFile,pTransDataB,uFileLen);            //IAPأISP.binļƵϲļͷλ
			}
		}
	}	
_END:
	if(pIapData!=NULL)
	{
		delete[] pIapData;
		pIapData = NULL;
	}
	if(pTransData!=NULL)
	{
		delete[] pTransData;
		pTransData = NULL;
	}
	if(pTransDataB!=NULL)
	{
		delete[] pTransDataB;
		pTransDataB = NULL;
	}
	if(pIspData!=NULL)   
	{
		delete[] pIspData;
		pIspData = NULL;
	}
	if(hFile!=INVALID_HANDLE_VALUE)
	{
		CloseHandle(hFile);
		hFile = INVALID_HANDLE_VALUE;
	}
	return pMergedFile;
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////

//ڴʱⰴʱһֱȴ豸,ֱֹȡ
DWORD WINAPI WaitSerDevInProc(LPVOID lpParameter)
{	
	DWORD Sel,i;
	BOOL RetVal;
	CHAR FmtStr[128] = "";
	
	EnableWindow(GetDlgItem(AfxMainHwnd,IDC_GetDevInfor_SER),FALSE);
	EnableWindow(GetDlgItem(AfxMainHwnd,IDC_AbortGetDevInfor),TRUE);
	Sel = (ULONG)lpParameter;
	
	AfxAbortSerDeviceWaitIn = FALSE;
	i = 0;
	while(!AfxAbortSerDeviceWaitIn)
	{
		RetVal= WCH55x_GetIspDeviceInfor(Sel,&AfxDnDev[Sel]); //ȡ豸Ϣ
		if( RetVal )
			break;
		else
			Sleep(0);
		i++;
		
		sprintf(FmtStr,"ȴ豸(%ld)",i);
		SetDlgItemText(AfxMainHwnd,IDC_DnDevInfor,FmtStr);			
	}
	if( RetVal )
	{//Ϣ		
		sprintf(FmtStr,"%s:UID:%02X-%02X-%02X-%02X-%02X-%02X-%02X-%02X,BTVER:%X%X.%X%X",
			AfxDnDev[Sel].DevIsOnline?"豸":"豸",
			AfxDnDev[Sel].IspMcuUID[0],AfxDnDev[Sel].IspMcuUID[1],AfxDnDev[Sel].IspMcuUID[2],
			AfxDnDev[Sel].IspMcuUID[3],AfxDnDev[Sel].IspMcuUID[4],AfxDnDev[Sel].IspMcuUID[5],
			AfxDnDev[Sel].IspMcuUID[6],AfxDnDev[Sel].IspMcuUID[7],
			AfxDnDev[Sel].IspVer[0],AfxDnDev[Sel].IspVer[1],AfxDnDev[Sel].IspVer[2],AfxDnDev[Sel].IspVer[3]); //BOOT 汾
		
		SetDlgItemText(AfxMainHwnd,IDC_DnDevInfor,FmtStr);
	}
	
	EnableWindow(GetDlgItem(AfxMainHwnd,IDC_GetDevInfor_SER),TRUE);
	EnableWindow(GetDlgItem(AfxMainHwnd,IDC_AbortGetDevInfor),FALSE);
	return 0;
}

//̼߳
DWORD WINAPI ISPFlashDnThread_CH55xUSB(LPVOID lpParameter)
{	
	Isp55xDevInforS *IspDev;	
	DWORD Sel;
	CHAR DevName[128] = "";
	UCHAR *DataBuf;
	DataBuf=NULL;
	ULONG uLen = 0;
	
	AfxIspIsRunning = TRUE;  //ڹ־	
	
	if(!CH55x_SetIspOption())
	{
		DbgPrint("ISPʧ!");
		goto _END;	
	}
	Sel = (ULONG)lpParameter;
	if( Sel >= AfxDnDevCnt )
	{
		DbgPrint("Invalid device index(%d)",Sel);
		goto _END;
	}
	IspDev = &AfxDnDev[Sel];
	
	sprintf(DevName,"%d#ISP DEV:%02X-%02X-%02X-%02X-%02X-%02X",
		IspDev->Index,
		IspDev->IspMcuUID[0],IspDev->IspMcuUID[1],IspDev->IspMcuUID[2],
		IspDev->IspMcuUID[3],IspDev->IspMcuUID[4],IspDev->IspMcuUID[5]);
	
	//CH103ҪȽⱣ
	if(AfxIspOption.IspMcuSeries == 4)
	{
		if(!WCH55x_IspRemoveProtect(Sel))
		{
			DbgPrint("豸Ᵽʧ!");
			return 0;
		}
	}

	//dataflash
	if(AfxIspOption.IsClearDataFlash)
	{
		if(!WCH55x_WriteDataFlash(IspDev->Index,0,&uLen,(UCHAR*)"CLEAR",TRUE))
		{
			DbgPrint("DataFlashʧ...");
			goto _END;
		}
	}

	DbgPrint("<%s> begin download...",DevName);
	

	{//жļǷ
		OFSTRUCT lpReOpenBuff = {0};
		
		if( AfxIspOption.IsEnableIAP )
		{			
			if ( OpenFile(AfxIspOption.IapFileName,&lpReOpenBuff,OF_EXIST) ==  HFILE_ERROR )
			{
				DbgPrint("IAPļڻʹãȷļǷڻûнISP");
				goto _END;
			}			
		}
		if ( OpenFile(AfxIspOption.UserFileName,&lpReOpenBuff,OF_EXIST) ==  HFILE_ERROR )
		{
			DbgPrint("ļڻʹ,ȷļǷڻûнISP");
			goto _END;
		}		
	}
	
	//عвܽö豸Ĳ
	EnableWindow(GetDlgItem(AfxMainHwnd,IDC_ScanDev),FALSE);
	EnableWindow(GetDlgItem(AfxMainHwnd,IDC_Download),FALSE);
	
	{//ļ
		AfxIspDnCnt++;
		DataBuf = MergeFile();
		
		if(!DataBuf)
		{
			DbgPrint("IAP,ISPļƴʧ!");
			goto _END;
		}
		
		if( !WCH55x_FlashProgramB(IspDev->Index,DataBuf,uOutFileLen,1,NULL,0,0) ) //س
		{
			DbgPrint("<%s> download failure.",DevName);
			AfxIspDnErrCnt++;
		}
		else
		{
			AfxIspDnSuccCnt++;
			DbgPrint("<%s> download succ",DevName);
		}
	}
	
	//عвܽö豸Ĳ
	EnableWindow(GetDlgItem(AfxMainHwnd,IDC_ScanDev),TRUE);
	EnableWindow(GetDlgItem(AfxMainHwnd,IDC_Download),TRUE);
	AfxIspIsRunning = FALSE;
	{
		CHAR FmtStr[128] = "";
		
		sprintf(FmtStr,":%d, ɹ:%d, ʧ:%d",AfxIspDnCnt,AfxIspDnSuccCnt,AfxIspDnErrCnt);
		SetDlgItemText(AfxMainHwnd,IDC_DnRecordShow,FmtStr);
		DbgPrint("%s",FmtStr);
	}
	
	if( AfxIspDevIsChanged ) //ڼ䣬豸Σ½ɨ
		PostMessage(GetDlgItem(AfxMainHwnd,IDC_ScanDev),BM_CLICK,0,0); //ɨ谴ť	
_END:
	EnableWindow(GetDlgItem(AfxMainHwnd,IDC_ScanDev),TRUE);
	EnableWindow(GetDlgItem(AfxMainHwnd,IDC_Download),TRUE);
	if(DataBuf!=NULL)
	{
		delete[] DataBuf;
	}
	return 0;
}

//̼У߳
DWORD WINAPI ISPFlashVerifyThread_CH55xUSB(LPVOID lpParameter)
{	
	Isp55xDevInforS *IspDev;	
	DWORD Sel;
	CHAR DevName[128] = "";
	UCHAR *DataBuf;
	DataBuf=NULL;
	ULONG uLen = 0;
	
	AfxIspIsRunning = TRUE;  //ڹ־	
	
	Sel = (ULONG)lpParameter;
	if( Sel >= AfxDnDevCnt )
	{
		DbgPrint("Invalid device index(%d)",Sel);
		goto _END;
	}
	if(!CH55x_SetIspOption())
	{
		DbgPrint("ISPʧ!");
		goto _END;	
	}
	IspDev = &AfxDnDev[Sel];
	
	sprintf(DevName,"%d#ISP DEV:%02X-%02X-%02X-%02X-%02X-%02X",
		IspDev->Index,
		IspDev->IspMcuUID[0],IspDev->IspMcuUID[1],IspDev->IspMcuUID[2],
		IspDev->IspMcuUID[3],IspDev->IspMcuUID[4],IspDev->IspMcuUID[5]);
	
	DbgPrint("<%s> begin verify...",DevName);
	{//жļǷ
		OFSTRUCT lpReOpenBuff = {0};
		
		if( AfxIspOption.IsEnableIAP )
		{			
			if ( OpenFile(AfxIspOption.IapFileName,&lpReOpenBuff,OF_EXIST) ==  HFILE_ERROR )
			{
				DbgPrint("IAPļڻʹãȷļǷڻûнISP");
				goto _END;
			}			
		}
		if ( OpenFile(AfxIspOption.UserFileName,&lpReOpenBuff,OF_EXIST) ==  HFILE_ERROR )
		{
			DbgPrint("ļڻʹ,ȷļǷڻûнISP");
			goto _END;
		}		
	}
	
	//عвܽö豸Ĳ
	EnableWindow(GetDlgItem(AfxMainHwnd,IDC_ScanDev),FALSE);
	EnableWindow(GetDlgItem(AfxMainHwnd,IDC_Download),FALSE);
	//CH103ҪȽⱣ
	if(AfxIspOption.IspMcuSeries == 4)
	{
		if(!WCH55x_IspRemoveProtect(Sel))
		{
			DbgPrint("豸Ᵽʧ!");
			return 0;
		}
	}

	//dataflash
	if(AfxIspOption.IsClearDataFlash)
	{
		if(!WCH55x_WriteDataFlash(IspDev->Index,0,&uLen,(UCHAR*)"CLEAR",TRUE))
		{
			DbgPrint("DataFlashʧ...");
			goto _END;
		}
	}
	DataBuf = MergeFile();
	
	if(!DataBuf)
	{
		DbgPrint("IAP,ISPļƴʧ!");
		goto _END;
	}
	{//ļ		
		if( !WCH55x_FlashVerifyB(IspDev->Index,DataBuf,uOutFileLen,1,NULL,0,0) ) //س
		{
			DbgPrint("<%s> verify failure.",DevName);
		}
		else
		{
			DbgPrint("<%s> verify succ.",DevName);
		}
	}
	
	//عвܽö豸Ĳ
	if( AfxIspDevIsChanged ) //ڼ䣬豸Σ½ɨ
		PostMessage(GetDlgItem(AfxMainHwnd,IDC_ScanDev),BM_CLICK,0,0); //ɨ谴ť	
_END:
	AfxIspIsRunning = FALSE;
	EnableWindow(GetDlgItem(AfxMainHwnd,IDC_ScanDev),TRUE);
	EnableWindow(GetDlgItem(AfxMainHwnd,IDC_Download),TRUE);
	if(DataBuf!=NULL)
	{
		delete[] DataBuf;
	}
	return 0;
}

//豸ö߳
DWORD WINAPI EnumIspDeviceProc(LPVOID lpParameter) //ULONG ScanDnDeviceAndShow()
{	
	ULONG i;
	CHAR FmtStr[512] = "";
	UCHAR  ChipType[2]={0};
	UCHAR  ChipSeries[2]={0};
	BOOL IsPreV230Boot=FALSE;
	
	//عвܽö豸Ĳ
	EnableWindow(GetDlgItem(AfxMainHwnd,IDC_ScanDev),FALSE);
	EnableWindow(GetDlgItem(AfxMainHwnd,IDC_Download),FALSE);
	
	ZeroMemory(AfxDnDev,sizeof(Isp55xDevInforS)*MAX_ISPDEV_NUM);
	AfxDnDevCnt = WCH55x_EnumDevices(AfxDnDev,10,&ChipSeries[0],&ChipType[0],&IsPreV230Boot);
	
	if( AfxDnDevCnt == 0)
	{
		DbgPrint("Not found isp device");
		SendDlgItemMessage(AfxMainHwnd,IDC_DeviceList,CB_RESETCONTENT,0,0);
		SetDlgItemText(AfxMainHwnd,IDC_DnDevInfor,"");
		
		goto Exit;
	}
	//豸б
	SendDlgItemMessage(AfxMainHwnd,IDC_DeviceList,CB_RESETCONTENT,0,0);
	
	for(i=0;i<AfxDnDevCnt;i++)
	{		
		if( AfxIspOption.IspInterface == 1 )
		{
			sprintf(FmtStr,"%d#ISP DEV:%s",
				AfxDnDev[i].Index,
				AfxDnDev[i].PortName);
		}
		else if( AfxIspOption.IspInterface == 0 )
		{		
			sprintf(FmtStr,"%d#ISP DEV:%02X-%02X-%02X-%02X-%02X-%02X-%02X-%02X",
				AfxDnDev[i].Index,
				AfxDnDev[i].IspMcuUID[0],AfxDnDev[i].IspMcuUID[1],AfxDnDev[i].IspMcuUID[2],
				AfxDnDev[i].IspMcuUID[3],AfxDnDev[i].IspMcuUID[4],AfxDnDev[i].IspMcuUID[5],
				AfxDnDev[i].IspMcuUID[6],AfxDnDev[i].IspMcuUID[7]);
			
		}
		else if( AfxIspOption.IspInterface == 2 )
		{
			sprintf(FmtStr,"%d#ISP DEV:%02X:%02X:%02X:%02X:%02X:%02X",
				AfxDnDev[i].Index,
				AfxDnDev[i].MacAddr[0],AfxDnDev[i].MacAddr[1],AfxDnDev[i].MacAddr[2],
				AfxDnDev[i].MacAddr[3],AfxDnDev[i].MacAddr[4],AfxDnDev[i].MacAddr[5]);
			
		}
		SendDlgItemMessage(AfxMainHwnd,IDC_DeviceList,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)FmtStr);
	}
	
	if( AfxIspOption.IspInterface == 1 )
		i = LastSerPortSel;
	else 
		i = 0;
	SendDlgItemMessage(AfxMainHwnd,IDC_DeviceList,CB_SETCURSEL,i,0);
	
	if( !AfxDnDev[i].IsCoolBoot )		//ûBOOTλ޸
		sprintf(FmtStr,"UID:%02X-%02X-%02X-%02X-%02X-%02X-%02X-%02X,BTVER:%X%X.%X%X(λܸ)",
		AfxDnDev[i].IspMcuUID[0],AfxDnDev[i].IspMcuUID[1],AfxDnDev[i].IspMcuUID[2],
		AfxDnDev[i].IspMcuUID[3],AfxDnDev[i].IspMcuUID[4],AfxDnDev[i].IspMcuUID[5],
		AfxDnDev[i].IspMcuUID[6],AfxDnDev[i].IspMcuUID[7],
		AfxDnDev[i].IspVer[0],AfxDnDev[i].IspVer[1],AfxDnDev[i].IspVer[2],AfxDnDev[i].IspVer[3]); //BOOT 汾
	else
		sprintf(FmtStr,"UID:%02X-%02X-%02X-%02X-%02X-%02X-%02X-%02X,BTVER:%X%X.%X%X",
		AfxDnDev[i].IspMcuUID[0],AfxDnDev[i].IspMcuUID[1],AfxDnDev[i].IspMcuUID[2],
		AfxDnDev[i].IspMcuUID[3],AfxDnDev[i].IspMcuUID[4],AfxDnDev[i].IspMcuUID[5],
		AfxDnDev[i].IspMcuUID[6],AfxDnDev[i].IspMcuUID[7],
		AfxDnDev[i].IspVer[0],AfxDnDev[i].IspVer[1],AfxDnDev[i].IspVer[2],AfxDnDev[i].IspVer[3]); //BOOT 汾
	
	
				
	SetDlgItemText(AfxMainHwnd,IDC_DnDevInfor,FmtStr);
Exit:
	//عвܽö豸Ĳ
	EnableWindow(GetDlgItem(AfxMainHwnd,IDC_ScanDev),TRUE);
	EnableWindow(GetDlgItem(AfxMainHwnd,IDC_Download),TRUE);
	
	AfxIspDevIsChanged = FALSE; //豸ɨ
	
	return AfxDnDevCnt;
}

void  ChooseChipSer(HWND hWnd,UINT uSel)
{	
	if(uSel == 0 )//CH55X
	{
		//оƬͺ
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_RESETCONTENT,0,0);
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH551");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH552");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH554");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH558");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH559");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_SETCURSEL,4,0);	
		
		//ʾؼ
		ShowWindow(GetDlgItem(hWnd,IDC_AutoIspNoKeySel),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_P5_RESET),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_CHECK_START_IAP),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDRN),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDR),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_LONG_RESET),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_P0_PULLUP),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_OSC_STRONG),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_BootPName),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_BootP1),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_BootP2),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EnableUsbPnpNotify),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_AutoDnAfterPlug),TRUE);
		//ؿؼ
		ShowWindow(GetDlgItem(hWnd,IDC_CH56x_EnableIce),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_CH56x_CodeBuf64K),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_LIMITV),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_COMBO_LIMITV),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_CHICK_SIMULAT579),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_BUTTON_SIMULIT),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_STOP_RST_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_USBD_MODE_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_POR_CTR_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_USPD_PU_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_STANDBY_RST_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_IWDG_SW_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_D0),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_D0),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_D1),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_D1),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP0),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP0),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP1),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP1),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP2),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP2),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP3),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP3),FALSE);
		CheckDlgButton(hWnd,IDC_CHECK_PROTECT,BST_CHECKED);
		EnableWindow(GetDlgItem(hWnd,IDC_CHECK_PROTECT),FALSE); 
		ShowWindow(GetDlgItem(hWnd,IDC_CH56x_SetDnDevMac),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_IspDevSetIP),FALSE);

		ShowWindow(GetDlgItem(hWnd,ID_STATIC_BAUD),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_COMBO_BAUD),FALSE);
		//ÿؼ
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_RESETCONTENT,0,0);
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"USB");
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"");
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_SETCURSEL,0,0);
		SetDlgItemText(hWnd,IDC_P5_RESET,"ʹP5.7Ϊֹλ");
		CheckDlgButton(hWnd,IDC_P0_PULLUP,BST_CHECKED);
		CheckDlgButton(hWnd,IDC_P5_RESET,BST_CHECKED);
		SetDlgItemText(AfxMainHwnd,IDC_EDIT_IAP_ADDR,"E000");
		CheckDlgButton(hWnd,IDC_AutoIspNoKeySel,BST_CHECKED);
		SetDlgItemText(hWnd,IDC_BootP1,_T("P4.6(Ĭ)"));
		SetDlgItemText(hWnd,IDC_BootP2,_T("P5.1"));
		CheckDlgButton(hWnd,IDC_BootP1,BST_CHECKED);
		CheckDlgButton(hWnd,IDC_ResetAfterIsp ,BST_UNCHECKED);
		EnableWindow(GetDlgItem(hWnd,IDC_ResetAfterIsp),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_CHECK_START_IAP),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDRN),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDR),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_IapDnFile),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_SelectIapFile),TRUE); 
		EnableWindow(GetDlgItem(hWnd,IDC_GetDevInfor_SER),FALSE); 
		EnableWindow(GetDlgItem(hWnd,IDC_AbortGetDevInfor),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_P5_RESET),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_Download),TRUE);
	}
	else if( uSel == 1 )//CH56X
	{
		//оƬͺ
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_RESETCONTENT,0,0);
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH561");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH563");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH565");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH566");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH567");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH568");
		
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_SETCURSEL,1,0);
		//ʾؼ
		ShowWindow(GetDlgItem(hWnd,IDC_CH56x_EnableIce),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_CH56x_CodeBuf64K),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_CH56x_SetDnDevMac),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_IspDevSetIP),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EnableUsbPnpNotify),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_AutoDnAfterPlug),TRUE);
		//ؿؼ
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_LIMITV),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_COMBO_LIMITV),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_CHICK_SIMULAT579),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_BUTTON_SIMULIT),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_STOP_RST_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_USBD_MODE_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_POR_CTR_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_USPD_PU_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_STANDBY_RST_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_IWDG_SW_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_D0),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_D0),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_D1),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_D1),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP0),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP0),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP1),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP1),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP2),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP2),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP3),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP3),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_P5_RESET),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_CHECK_START_IAP),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDRN),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDR),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_LONG_RESET),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_P0_PULLUP),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_OSC_STRONG),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_BootPName),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_BootP1),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_BootP2),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_AutoIspNoKeySel),FALSE);
		CheckDlgButton(hWnd,IDC_CHECK_PROTECT,BST_CHECKED);
		EnableWindow(GetDlgItem(hWnd,IDC_CHECK_PROTECT),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_BAUD),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_COMBO_BAUD),FALSE);

		//ÿؼ
		CheckDlgButton(hWnd,IDC_AutoIspNoKeySel ,BST_UNCHECKED);
		CheckDlgButton(hWnd,IDC_CH56x_CodeBuf64K ,BST_CHECKED);
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_RESETCONTENT,0,0);
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"USB");
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"");
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"");
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_SETCURSEL,0,0);
		ShowWindow(GetDlgItem(hWnd,IDC_IspDevSetIP),TRUE);
		CheckDlgButton(hWnd,IDC_ResetAfterIsp ,BST_UNCHECKED);
		EnableWindow(GetDlgItem(hWnd,IDC_ResetAfterIsp),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_CHECK_START_IAP),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDRN),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDR),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_IapDnFile),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_SelectIapFile),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_GetDevInfor_SER),FALSE); 
		EnableWindow(GetDlgItem(hWnd,IDC_AbortGetDevInfor),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_P5_RESET),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_Download),TRUE);
	}
	else if( uSel == 2 )//CH54X
	{
		//оƬͺ
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_RESETCONTENT,0,0);
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH546");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH547");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH548");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH549");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_SETCURSEL,3,0);	
		//ʾؼ
		CheckDlgButton(hWnd,IDC_CHECK_PROTECT,BST_CHECKED);
		EnableWindow(GetDlgItem(hWnd,IDC_CHECK_PROTECT),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_AutoIspNoKeySel),TRUE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_LIMITV),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_COMBO_LIMITV),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_LONG_RESET),TRUE); 
		ShowWindow(GetDlgItem(hWnd,IDC_P5_RESET),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_BootPName),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_BootP1),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_BootP2),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_CHECK_START_IAP),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDRN),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDR),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EnableUsbPnpNotify),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_AutoDnAfterPlug),TRUE);
		//ؿؼ
		ShowWindow(GetDlgItem(hWnd,IDC_CHICK_SIMULAT579),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_BUTTON_SIMULIT),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_STOP_RST_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_USBD_MODE_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_POR_CTR_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_USPD_PU_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_STANDBY_RST_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_IWDG_SW_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_D0),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_D0),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_D1),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_D1),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP0),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP0),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP1),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP1),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP2),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP2),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP3),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP3),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_P0_PULLUP),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_OSC_STRONG),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_CH56x_EnableIce),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_CH56x_CodeBuf64K),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_CH56x_SetDnDevMac),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_IspDevSetIP),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_BAUD),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_COMBO_BAUD),FALSE);
		//ÿؼ
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_RESETCONTENT,0,0);
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"USB");
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"");
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_SETCURSEL,0,0);
		CheckDlgButton(hWnd,IDC_AutoIspNoKeySel ,BST_CHECKED);
		SetDlgItemText(hWnd,IDC_P5_RESET,"ʹP5.7Ϊֹλ");
		SetDlgItemText(hWnd,IDC_BootP1,_T("P51(Ĭ)"));
		SetDlgItemText(hWnd,IDC_BootP2,_T("P15"));
		CheckDlgButton(hWnd,IDC_BootP1 ,BST_CHECKED);
		SendDlgItemMessage(hWnd,IDC_COMBO_LIMITV,CB_RESETCONTENT,0,0);
		SendDlgItemMessage(hWnd,IDC_COMBO_LIMITV,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"2.4");
		SendDlgItemMessage(hWnd,IDC_COMBO_LIMITV,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"2.7");  
		SendDlgItemMessage(hWnd,IDC_COMBO_LIMITV,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"3.0");  
		SendDlgItemMessage(hWnd,IDC_COMBO_LIMITV,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"3.6");  
		SendDlgItemMessage(hWnd,IDC_COMBO_LIMITV,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"4.0");  
		SendDlgItemMessage(hWnd,IDC_COMBO_LIMITV,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"4.3");  
		SendDlgItemMessage(hWnd,IDC_COMBO_LIMITV,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"4.6");  
		SendDlgItemMessage(hWnd,IDC_COMBO_LIMITV,CB_SETCURSEL,0,0);
		CheckDlgButton(hWnd,IDC_ResetAfterIsp ,BST_UNCHECKED);
		EnableWindow(GetDlgItem(hWnd,IDC_ResetAfterIsp),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_CHECK_START_IAP),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDRN),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDR),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_IapDnFile),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_SelectIapFile),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_GetDevInfor_SER),FALSE); 
		EnableWindow(GetDlgItem(hWnd,IDC_AbortGetDevInfor),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_P5_RESET),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_Download),TRUE);
	}
	else if( uSel == 3 )//CH57X
	{
		//оƬͺ
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_RESETCONTENT,0,0);
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH571");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH573");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH577");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH578");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH579");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_SETCURSEL,2,0);	

		SendDlgItemMessage(hWnd,IDC_COMBO_BAUD,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"115200");
		SendDlgItemMessage(hWnd,IDC_COMBO_BAUD,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"1M");	
		SendDlgItemMessage(hWnd,IDC_COMBO_BAUD,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"2M");
		SendDlgItemMessage(hWnd,IDC_COMBO_BAUD,CB_SETCURSEL,1,0);	

		CheckDlgButton(hWnd,IDC_CHECK_PROTECT,BST_CHECKED);
		EnableWindow(GetDlgItem(hWnd,IDC_CHECK_PROTECT),TRUE);
		//ʾؼ
		ShowWindow(GetDlgItem(hWnd,IDC_AutoIspNoKeySel),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_P5_RESET),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_BootPName),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_BootP1),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_BootP2),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_CHECK_START_IAP),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDRN),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDR),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_CHICK_SIMULAT579),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EnableUsbPnpNotify),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_AutoDnAfterPlug),TRUE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_BAUD),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_COMBO_BAUD),TRUE);
		//ؿؼ
		ShowWindow(GetDlgItem(hWnd,IDC_STOP_RST_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_USBD_MODE_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_POR_CTR_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_USPD_PU_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_STANDBY_RST_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_IWDG_SW_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_D0),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_D0),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_D1),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_D1),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP0),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP0),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP1),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP1),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP2),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP2),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP3),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP3),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_P0_PULLUP),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_OSC_STRONG),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_CH56x_EnableIce),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_CH56x_CodeBuf64K),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_LIMITV),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_COMBO_LIMITV),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_LONG_RESET),FALSE); 
		ShowWindow(GetDlgItem(hWnd,IDC_CH56x_SetDnDevMac),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_IspDevSetIP),FALSE);
		//ÿؼ
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_RESETCONTENT,0,0);
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"USB");
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"");
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_SETCURSEL,0,0);
		CheckDlgButton(hWnd,IDC_AutoIspNoKeySel ,BST_CHECKED);
		SetDlgItemText(hWnd,IDC_P5_RESET,"ʹRSTΪֹλ");
		SetDlgItemText(hWnd,IDC_BootP1,_T("PB22(Ĭ)"));
		SetDlgItemText(hWnd,IDC_BootP2,_T("PB11"));
		CheckDlgButton(hWnd,IDC_BootP1 ,BST_CHECKED);
		CheckDlgButton(hWnd,IDC_P5_RESET ,BST_CHECKED); 
		CheckDlgButton(hWnd,IDC_ResetAfterIsp ,BST_CHECKED);
		EnableWindow(GetDlgItem(hWnd,IDC_ResetAfterIsp),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_CHECK_START_IAP),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDRN),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDR),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_IapDnFile),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_SelectIapFile),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_GetDevInfor_SER),FALSE); 
		EnableWindow(GetDlgItem(hWnd,IDC_AbortGetDevInfor),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_P5_RESET),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_Download),TRUE);
	} 
	else if( uSel == 4 )//CH32f10X
	{
		//оƬͺ
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_RESETCONTENT,0,0);
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH32F103");	
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_SETCURSEL,0,0);	
		CheckDlgButton(hWnd,IDC_CHECK_PROTECT,BST_CHECKED);
		EnableWindow(GetDlgItem(hWnd,IDC_CHECK_PROTECT),TRUE);
		//ʾؼ
		ShowWindow(GetDlgItem(hWnd,IDC_STOP_RST_32F),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_USBD_MODE_32F),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_POR_CTR_32F),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_USPD_PU_32F),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_STANDBY_RST_32F),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_IWDG_SW_32F),TRUE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_D0),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_D0),TRUE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_D1),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_D1),TRUE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP0),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP0),TRUE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP1),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP1),TRUE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP2),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP2),TRUE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP3),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP3),TRUE);	
		//ؿؼ
		ShowWindow(GetDlgItem(hWnd,IDC_AutoIspNoKeySel),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_P0_PULLUP),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_OSC_STRONG),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_CH56x_EnableIce),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_CH56x_CodeBuf64K),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_LIMITV),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_COMBO_LIMITV),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_LONG_RESET),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_P5_RESET),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_BootPName),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_BootP1),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_BootP2),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_CHECK_START_IAP),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDRN),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDR),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_CHICK_SIMULAT579),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_BUTTON_SIMULIT),FALSE);
		CheckDlgButton(hWnd,IDC_ResetAfterIsp ,BST_UNCHECKED);
		EnableWindow(GetDlgItem(hWnd,IDC_ResetAfterIsp),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_CH56x_SetDnDevMac),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_IspDevSetIP),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EnableUsbPnpNotify),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_AutoDnAfterPlug),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_BAUD),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_COMBO_BAUD),FALSE);
		//ÿؼ
		CheckDlgButton(hWnd,IDC_STOP_RST_32F ,BST_CHECKED); 
		CheckDlgButton(hWnd,IDC_STANDBY_RST_32F ,BST_CHECKED);
		CheckDlgButton(hWnd,IDC_IWDG_SW_32F ,BST_CHECKED);
		SetDlgItemText(hWnd,IDC_EDIT_CH32F_D0,"FF");
		SetDlgItemText(hWnd,IDC_EDIT_CH32F_D1,"FF");
		SetDlgItemText(hWnd,IDC_EDIT_CH32F_WRP0,"FF");
		SetDlgItemText(hWnd,IDC_EDIT_CH32F_WRP1,"FF");
		SetDlgItemText(hWnd,IDC_EDIT_CH32F_WRP2,"FF");
		SetDlgItemText(hWnd,IDC_EDIT_CH32F_WRP3,"FF");
		EnableWindow(GetDlgItem(hWnd,IDC_CHECK_START_IAP),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDRN),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDR),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_IapDnFile),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_SelectIapFile),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_GetDevInfor_SER),FALSE); 
		EnableWindow(GetDlgItem(hWnd,IDC_AbortGetDevInfor),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_P5_RESET),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_Download),TRUE);
	}
	else if( uSel == 5 )//CH32v10X
	{
		//оƬͺ
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_RESETCONTENT,0,0);
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH32V103");	
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_SETCURSEL,0,0);	
		CheckDlgButton(hWnd,IDC_CHECK_PROTECT,BST_CHECKED);
		EnableWindow(GetDlgItem(hWnd,IDC_CHECK_PROTECT),TRUE);
		//ʾؼ
		ShowWindow(GetDlgItem(hWnd,IDC_STOP_RST_32F),TRUE);	
		ShowWindow(GetDlgItem(hWnd,IDC_POR_CTR_32F),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_STANDBY_RST_32F),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_IWDG_SW_32F),TRUE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_D0),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_D0),TRUE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_D1),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_D1),TRUE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP0),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP0),TRUE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP1),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP1),TRUE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP2),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP2),TRUE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_CH32F_WRP3),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_CH32F_WRP3),TRUE);	
		//ؿؼ
		ShowWindow(GetDlgItem(hWnd,IDC_USBD_MODE_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_USPD_PU_32F),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_AutoIspNoKeySel),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_P0_PULLUP),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_OSC_STRONG),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_CH56x_EnableIce),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_CH56x_CodeBuf64K),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_LIMITV),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_COMBO_LIMITV),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_LONG_RESET),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_P5_RESET),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_BootPName),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_BootP1),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_BootP2),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_CHECK_START_IAP),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDRN),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDR),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_CHICK_SIMULAT579),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_BUTTON_SIMULIT),FALSE);
		CheckDlgButton(hWnd,IDC_ResetAfterIsp ,BST_UNCHECKED);
		EnableWindow(GetDlgItem(hWnd,IDC_ResetAfterIsp),TRUE);
		ShowWindow(GetDlgItem(hWnd,IDC_CH56x_SetDnDevMac),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_IspDevSetIP),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_EnableUsbPnpNotify),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_AutoDnAfterPlug),FALSE);
		ShowWindow(GetDlgItem(hWnd,ID_STATIC_BAUD),FALSE);
		ShowWindow(GetDlgItem(hWnd,IDC_COMBO_BAUD),FALSE);
		//ÿؼ
		CheckDlgButton(hWnd,IDC_STOP_RST_32F ,BST_CHECKED); 
		CheckDlgButton(hWnd,IDC_STANDBY_RST_32F ,BST_CHECKED);
		CheckDlgButton(hWnd,IDC_IWDG_SW_32F ,BST_CHECKED);
		SetDlgItemText(hWnd,IDC_EDIT_CH32F_D0,"FF");
		SetDlgItemText(hWnd,IDC_EDIT_CH32F_D1,"FF");
		SetDlgItemText(hWnd,IDC_EDIT_CH32F_WRP0,"FF");
		SetDlgItemText(hWnd,IDC_EDIT_CH32F_WRP1,"FF");
		SetDlgItemText(hWnd,IDC_EDIT_CH32F_WRP2,"FF");
		SetDlgItemText(hWnd,IDC_EDIT_CH32F_WRP3,"FF");
		EnableWindow(GetDlgItem(hWnd,IDC_CHECK_START_IAP),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDRN),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDR),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_IapDnFile),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_SelectIapFile),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_GetDevInfor_SER),FALSE); 
		EnableWindow(GetDlgItem(hWnd,IDC_AbortGetDevInfor),FALSE);
		EnableWindow(GetDlgItem(hWnd,IDC_P5_RESET),TRUE);
		EnableWindow(GetDlgItem(hWnd,IDC_Download),TRUE);
	}
}

//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	AfxMainHwnd = hWnd;
	
	switch (message)
	{
	case WM_INITDIALOG:
		SendMessage(hWnd, WM_SETICON, ICON_BIG, (long)hIcon);  //óͼ
		//ʼؽӿ				
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"USB");
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"");
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"");
		SendDlgItemMessage(hWnd,IDC_DnInterface,CB_SETCURSEL,0,0);
		//оƬϵ
		SendDlgItemMessage(hWnd,IDC_ChipSeries,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"8λCH55x");
		SendDlgItemMessage(hWnd,IDC_ChipSeries,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"32λCH56x");
		SendDlgItemMessage(hWnd,IDC_ChipSeries,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"8λCH54x");
		SendDlgItemMessage(hWnd,IDC_ChipSeries,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"32λCH57x");
		SendDlgItemMessage(hWnd,IDC_ChipSeries,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"32λCH32F1");
		SendDlgItemMessage(hWnd,IDC_ChipSeries,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"32λCH32V1");
		SendDlgItemMessage(hWnd,IDC_ChipSeries,CB_SETCURSEL,0,0);
		//ӳʼоƬ
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH551");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH552");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH554");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH558");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"CH559");
		SendDlgItemMessage(hWnd,IDC_ChipType,CB_SETCURSEL,4,0);
		
		SetFocus(GetDlgItem(AfxMainHwnd,IDC_ChipType));
		
		EnableWindow(GetDlgItem(AfxMainHwnd,IDC_GetDevInfor_SER),FALSE);
		EnableWindow(GetDlgItem(AfxMainHwnd,IDC_AbortGetDevInfor),FALSE);
		
		//ĬϵоƬͺؽӿԼ֪ͨ
		if( !CH55x_SetIspOption() )
		{
			DbgPrint("Set isp option failure.");
			break;
		}
		//ɨ豸
		SendDlgItemMessage(hWnd,IDC_ScanDev,BM_CLICK,0,0);
		srand(time(NULL));
		SendDlgItemMessage(hWnd,IDC_RefreshAdapList,BM_CLICK,0,0);
		
		SendDlgItemMessage(hWnd,IDC_ChipSeries,CB_SETCURSEL,0,0);
		ChooseChipSer(hWnd,0);
		
		break;
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{	
		case IDC_RefreshAdapList:       //ˢ			
			{
				ULONG i,Cnt;
				CHAR FmtStr[128];
				
				SendDlgItemMessage(hWnd,IDC_LocalAdapList,CB_RESETCONTENT,2,2);
				Cnt = EnumNetAdapter();
				for(i=0;i<Cnt;i++)
				{
					sprintf(FmtStr,"%d.%s",i+1,AfxNetAdap[i].szAdapterDescriptor);	
					SendDlgItemMessage(hWnd,IDC_LocalAdapList,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)FmtStr);
				}
				SendDlgItemMessage(hWnd,IDC_LocalAdapList,CB_SETCURSEL,0,0);
				
				sprintf(FmtStr,"LocalIP:%s,MAC:%s",AfxNetAdap[0].szIPAddress,AfxNetAdap[0].szMacAddress);
				SetDlgItemText(AfxMainHwnd,IDC_LocalAdapInfor,FmtStr);
				{//豸IPַ뱾IPΪͬһ
					in_addr IpAddr = {0};
					
					IpAddr.S_un.S_addr = AfxNetAdap[0].dwIPAddress+0x01000000;		
					SetDlgItemText(AfxMainHwnd,IDC_IspDevSetIP,inet_ntoa(IpAddr));
				}
			}
			break;
		case IDC_LocalAdapList:         //AfxLocalIPѡ仯
			if( (wmEvent == CBN_SELCHANGE) ) 
			{
				ULONG i;
				CHAR FmtStr[512];
				
				//ˢ豸б
				i = SendDlgItemMessage(hWnd,IDC_LocalAdapList,CB_GETCURSEL,0,0);
				if( i == CB_ERR )
					break;
				sprintf(FmtStr,"LocalIP:%s,MAC:%s",AfxNetAdap[i].szIPAddress,AfxNetAdap[i].szMacAddress);
				SetDlgItemText(AfxMainHwnd,IDC_LocalAdapInfor,FmtStr);
				
				
				{//豸IPַ뱾IPΪͬһ
					in_addr IpAddr = {0};
					
					IpAddr.S_un.S_addr = AfxNetAdap[i].dwIPAddress+0x01000000;	//Ϊ1	
					SetDlgItemText(AfxMainHwnd,IDC_IspDevSetIP,inet_ntoa(IpAddr));
				}
			}
			break;
			
		case IDC_CHICK_SIMULAT579:
			{
				UINT bSimulit = IsDlgButtonChecked(hWnd,IDC_CHICK_SIMULAT579);
				if(bSimulit==1)  //
				{
					EnableWindow(GetDlgItem(hWnd,IDC_P5_RESET),FALSE);
					EnableWindow(GetDlgItem(hWnd,IDC_CHECK_PROTECT),FALSE);
					CheckDlgButton(hWnd,IDC_P5_RESET,BST_UNCHECKED);
					EnableWindow(GetDlgItem(hWnd,IDC_Download),FALSE);
					CheckDlgButton(hWnd,IDC_CHECK_PROTECT,BST_UNCHECKED);
					CheckDlgButton(hWnd,IDC_EnableUsbPnpNotify,BST_UNCHECKED);
					CheckDlgButton(hWnd,IDC_AutoDnAfterPlug,BST_UNCHECKED);
					ShowWindow(GetDlgItem(hWnd,IDC_BUTTON_SIMULIT),TRUE);
				}
				else
				{
					EnableWindow(GetDlgItem(hWnd,IDC_P5_RESET),TRUE);
					EnableWindow(GetDlgItem(hWnd,IDC_CHECK_PROTECT),TRUE);
					EnableWindow(GetDlgItem(hWnd,IDC_Download),TRUE);
					CheckDlgButton(hWnd,IDC_P5_RESET,BST_CHECKED);
					CheckDlgButton(hWnd,IDC_CHECK_PROTECT,BST_CHECKED);
					ShowWindow(GetDlgItem(hWnd,IDC_BUTTON_SIMULIT),FALSE);
				}
			}
			break;
		case IDC_BUTTON_SIMULIT:
			{
				DWORD Sel = SendDlgItemMessage(hWnd,IDC_DeviceList,CB_GETCURSEL,0,0);
				if( Sel == CB_ERR )
				{
					MessageBox(AfxMainHwnd,"ѡ豸ߵǰûҵ豸","WCH55xDLL DEMO",MB_ICONERROR);
					DbgPrint("ѡ豸ߵǰûҵ豸.");
					break;
				}
				if( !CH55x_SetIspOption() )
				{
					DbgPrint("Set isp option failure.");
					break;
				}
				WCH55x_IspSumilat(Sel);
			}
			break;
		case IDC_EepromWrite:          //DataFlashд
			{
				DWORD Sel,StartAddr,WriteLen,i,RndData;
				UCHAR DataBuf[6400] = {0},RDataBuf[6400] = {0};
				
				Sel = SendDlgItemMessage(hWnd,IDC_DeviceList,CB_GETCURSEL,0,0);
				if( Sel == CB_ERR )
				{
					MessageBox(AfxMainHwnd,"ѡ豸ߵǰûҵ豸","WCH55xDLL DEMO",MB_ICONERROR);
					DbgPrint("ѡ豸ߵǰûҵ豸.");
					break;
				}				
				
				//д֮ǰвдд룬ȶ޸ָλõݺд
				//Ĭ1KΪλڲжʵʴС
				StartAddr = 0;
				WriteLen = 1*1024;
				
				//DataBuf[0] = rand()%0x100;
				RndData = (rand()%256);
				for(i=0;i<WriteLen;i++)
					DataBuf[i] = (UCHAR)RndData;
				//ģдֽ
				RndData = rand()%WriteLen;
				DataBuf[RndData] = 0x5A;
				DataBuf[RndData+1] = 0xA5;
				
				if( !WCH55x_WriteDataFlash(Sel,StartAddr,&WriteLen,DataBuf,TRUE) )
				{
					DbgPrint("дEEPROM([%02X:%02X])ʧ",StartAddr,WriteLen);
				}
				else
					DbgPrint("дEEPROM([%02X:%02X]=%02x,EEPROM([%02X:2]=%02X %02X)ɹ",StartAddr,WriteLen,DataBuf[0],RndData,DataBuf[RndData],DataBuf[RndData+1]);
				
				if( !WCH55x_ReadDataFlash(Sel,StartAddr,&WriteLen,RDataBuf) )
				{
					DbgPrint("ȡEEPROM(%02X:%02X)ʧ",StartAddr,WriteLen);
				}
				else
					DbgPrint("EEPROM([%02X:%02X]=%02x,EEPROM([%02X:2]=%02X %02X),%02X-%02Xɹ",StartAddr,WriteLen,DataBuf[0],RndData,RDataBuf[RndData],RDataBuf[RndData+1],
					RDataBuf[5*1024-2],RDataBuf[5*1024-1]);
				//ȽдǷȷ
				if( memcmp(DataBuf,RDataBuf,WriteLen) != 0)
				{
					DbgPrint("дд");
				}
				else
				{
					DbgPrint("дȷ");
				}
			}
			break;
		case IDC_EepromRead:               //DataFlash
			{
				DWORD Sel,StartAddr,ReadLen;
				UCHAR DataBuf[4096] = {0};
				
				Sel = SendDlgItemMessage(hWnd,IDC_DeviceList,CB_GETCURSEL,0,0);
				if( Sel == CB_ERR )
				{
					MessageBox(AfxMainHwnd,"ѡ豸ߵǰûҵ豸","WCH55xDLL DEMO",MB_ICONERROR);
					DbgPrint("ѡ豸ߵǰûҵ豸.");
					break;
				}		
				
				StartAddr = 0;
				ReadLen = 4096;
				if( !WCH55x_ReadDataFlash(0,0,&ReadLen,DataBuf) )
				{
					DbgPrint("ȡEEPROM(%X:%X)ʧ",StartAddr,ReadLen);
				}
				else
					DbgPrint("ȡEEPROM(%X:%X)ɹ",StartAddr,ReadLen);
			}
			break;
		case IDC_AbortGetDevInfor://ȡڻȡ豸Ϣ
			{
				AfxAbortSerDeviceWaitIn = TRUE;
				DbgPrint("ֹȴ豸");
			}
			break;
		case IDC_GetDevInfor_SER: //ͨڻȡ豸Ϣ
			{
				DWORD Sel;
				
				SetDlgItemText(AfxMainHwnd,IDC_DnDevInfor,"");
				Sel = SendDlgItemMessage(hWnd,IDC_DeviceList,CB_GETCURSEL,0,0);
				if( Sel == CB_ERR )
				{
					MessageBox(AfxMainHwnd,"ѡش","WCH55xDLL DEMO",MB_ICONERROR);
					DbgPrint("ѡش.");
					break;
				}
				
				if( ( AfxIspOption.IspInterface == 1 )&&(AfxIspOption.IsNoKeyDnAtSer) )//
				{					
					CloseHandle(CreateThread(NULL,0,WaitSerDevInProc,(PVOID)Sel,0,NULL));  //ɨ豸߳
				}
				else
				{		
					CHAR FmtStr[128] = "";
					
					if( !WCH55x_GetIspDeviceInfor(Sel,&AfxDnDev[Sel]) )
					{
						DbgPrint("ͨڻȡ豸Ϣʧ.");						
					}
					else
					{
						sprintf(FmtStr,"%s:UID:%02X-%02X-%02X-%02X-%02X-%02X-%02X-%02X,BTVER:%X%X.%X%X",
							AfxDnDev[Sel].DevIsOnline?"豸":"豸",
							AfxDnDev[Sel].IspMcuUID[0],AfxDnDev[Sel].IspMcuUID[1],AfxDnDev[Sel].IspMcuUID[2],
							AfxDnDev[Sel].IspMcuUID[3],AfxDnDev[Sel].IspMcuUID[4],AfxDnDev[Sel].IspMcuUID[5],
							AfxDnDev[Sel].IspMcuUID[6],AfxDnDev[Sel].IspMcuUID[7],
							AfxDnDev[Sel].IspVer[0],AfxDnDev[Sel].IspVer[1],AfxDnDev[Sel].IspVer[2],AfxDnDev[Sel].IspVer[3]); //BOOT 汾
						
						SetDlgItemText(AfxMainHwnd,IDC_DnDevInfor,FmtStr);
					}
				}
				
			}
			break;
		case IDC_SetIspOption: //ISPѡ
			if( !CH55x_SetIspOption() )
				DbgPrint("Set isp option failure.");
			else
				DbgPrint("Set isp option succ");
			break;
		case IDC_DnInterface://½ӿ豸б
			if( wmEvent == CBN_SELCHANGE ) 
			{
				if( SendDlgItemMessage(hWnd,IDC_DnInterface,CB_GETCURSEL,0,0) == 1 )//
				{
					ShowWindow(GetDlgItem(hWnd,IDC_EnableUsbPnpNotify),FALSE);
					ShowWindow(GetDlgItem(hWnd,IDC_AutoDnAfterPlug),FALSE);
					EnableWindow(GetDlgItem(AfxMainHwnd,IDC_GetDevInfor_SER),TRUE);
					EnableWindow(GetDlgItem(AfxMainHwnd,IDC_AbortGetDevInfor),TRUE);
				}
				else
				{
					ShowWindow(GetDlgItem(hWnd,IDC_EnableUsbPnpNotify),TRUE);
					ShowWindow(GetDlgItem(hWnd,IDC_AutoDnAfterPlug),TRUE);
					EnableWindow(GetDlgItem(AfxMainHwnd,IDC_GetDevInfor_SER),FALSE);
					EnableWindow(GetDlgItem(AfxMainHwnd,IDC_AbortGetDevInfor),FALSE);
				}
				{//²豸
					//豸б
					SendDlgItemMessage(AfxMainHwnd,IDC_DeviceList,CB_RESETCONTENT,0,0);
					SetDlgItemText(AfxMainHwnd,IDC_DnDevInfor,"");
				}
			}
			break;
		case IDC_ChipSeries:      //оƬϵб
			if( wmEvent == CBN_SELCHANGE ) 
			{
				ChooseChipSer(hWnd,SendDlgItemMessage(hWnd,IDC_ChipSeries,CB_GETCURSEL,0,0));
			}
			break;
		case IDC_ChipType:      //оƬб
			if( (wmEvent == CBN_SELCHANGE) || (wmEvent == CBN_SETFOCUS) ) //½ӿ豸б
			{
				ULONG ChipSeries = 0,ChipType = 0;
				
				ChipSeries = SendDlgItemMessage(hWnd,IDC_ChipSeries,CB_GETCURSEL,0,0); 
				ChipType = SendDlgItemMessage(hWnd,IDC_ChipType,CB_GETCURSEL,0,0);
				
				if( ChipSeries == 0 )      //CH55X 
				{
					SendDlgItemMessage(hWnd,IDC_DnInterface,CB_RESETCONTENT,0,0);
					SendDlgItemMessage(hWnd,IDC_DnInterface,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"USB");
					SendDlgItemMessage(hWnd,IDC_DnInterface,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"");  
					SendDlgItemMessage(hWnd,IDC_DnInterface,CB_SETCURSEL,0,0);
					//CH554֧
					if( ChipType < 3 )//CH554֧
					{
						SetDlgItemText(hWnd,IDC_P5_RESET,"ʹRST Pin Ϊֹλ");
						ShowWindow(GetDlgItem(hWnd,IDC_OSC_STRONG),FALSE);
						ShowWindow(GetDlgItem(hWnd,IDC_P0_PULLUP),FALSE);
						
						ShowWindow(GetDlgItem(hWnd,IDC_CHECK_START_IAP),FALSE);
						ShowWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDRN),FALSE);
						ShowWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDR),FALSE);
						EnableWindow(GetDlgItem(hWnd,IDC_IapDnFile),FALSE);
						EnableWindow(GetDlgItem(hWnd,IDC_SelectIapFile),FALSE);
						SetDlgItemText(hWnd,IDC_BootP1,_T("P3.6(Ĭ)"));
						SetDlgItemText(hWnd,IDC_BootP2,_T("P1.5"));	
						ShowWindow(GetDlgItem(hWnd,IDC_LONG_RESET),TRUE);
						ShowWindow(GetDlgItem(hWnd,IDC_CH56x_EnableIce),FALSE);
						ShowWindow(GetDlgItem(hWnd,IDC_BootPName),TRUE);
						ShowWindow(GetDlgItem(hWnd,IDC_AutoIspNoKeySel),TRUE);	
						
					}
					else
					{
						SetDlgItemText(hWnd,IDC_P5_RESET,"ʹP5.7Ϊֹλ");
						ShowWindow(GetDlgItem(hWnd,IDC_OSC_STRONG),TRUE);
						ShowWindow(GetDlgItem(hWnd,IDC_P0_PULLUP),TRUE);
						
						ShowWindow(GetDlgItem(hWnd,IDC_CHECK_START_IAP),TRUE);
						ShowWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDRN),TRUE);
						ShowWindow(GetDlgItem(hWnd,IDC_EDIT_IAP_ADDR),TRUE);
						EnableWindow(GetDlgItem(hWnd,IDC_IapDnFile),TRUE);
						EnableWindow(GetDlgItem(hWnd,IDC_SelectIapFile),TRUE);
						
						SetDlgItemText(hWnd,IDC_BootP1,_T("P4.6(Ĭ)"));
						SetDlgItemText(hWnd,IDC_BootP2,_T("P5.1"));
						ShowWindow(GetDlgItem(hWnd,IDC_LONG_RESET),TRUE);
						ShowWindow(GetDlgItem(hWnd,IDC_CH56x_EnableIce),FALSE);
						ShowWindow(GetDlgItem(hWnd,IDC_BootPName),TRUE);
						ShowWindow(GetDlgItem(hWnd,IDC_AutoIspNoKeySel),TRUE);	
						
					}
				}
				else if(ChipSeries == 1)//CH56X-CH569
				{
					if( ChipType < 2 )//CH561,CH563
					{
						ShowWindow(GetDlgItem(hWnd,IDC_P5_RESET),FALSE);
						CheckDlgButton(hWnd,IDC_P5_RESET,BST_UNCHECKED);
						
						ShowWindow(GetDlgItem(hWnd,IDC_CH56x_EnableIce),TRUE);
						CheckDlgButton(hWnd,IDC_CH56x_EnableIce,BST_UNCHECKED);
						ShowWindow(GetDlgItem(hWnd,IDC_CH56x_CodeBuf64K),TRUE);
						CheckDlgButton(hWnd,IDC_CH56x_CodeBuf64K,BST_CHECKED);
					}
					else
					{
						
						SetDlgItemText(hWnd,IDC_P5_RESET,"ʹRSTΪֹλ");
						CheckDlgButton(hWnd,IDC_P5_RESET,BST_CHECKED);
						ShowWindow(GetDlgItem(hWnd,IDC_P5_RESET),TRUE);
						
						ShowWindow(GetDlgItem(hWnd,IDC_CH56x_EnableIce),FALSE);
						CheckDlgButton(hWnd,IDC_CH56x_EnableIce,BST_UNCHECKED);
						ShowWindow(GetDlgItem(hWnd,IDC_CH56x_CodeBuf64K),FALSE);
						CheckDlgButton(hWnd,IDC_CH56x_CodeBuf64K,BST_UNCHECKED);
						
					}
				}
				
				{//²豸
					//豸б
					SendDlgItemMessage(AfxMainHwnd,IDC_DeviceList,CB_RESETCONTENT,0,0);
					SetDlgItemText(AfxMainHwnd,IDC_DnDevInfor,"");
				}
			}
			break;
		case IDC_ScanDev: //ɨ豸
			{
				ULONG ThreadID = 0;
				if( !CH55x_SetIspOption() )
					DbgPrint("Set isp option failure.");
				CloseHandle(CreateThread(NULL,0,EnumIspDeviceProc,NULL,0,&ThreadID));  //ɨ豸߳
			}
			break;
		case IDC_Verify:   //У̼
			{
				DWORD ThreadID,Sel;
				Sel = SendDlgItemMessage(hWnd,IDC_DeviceList,CB_GETCURSEL,0,0);
				if( Sel == CB_ERR )
				{
					MessageBox(AfxMainHwnd,"ѡ豸ߵǰûҵ豸","WCH55xDLL DEMO",MB_ICONERROR);
					DbgPrint("ѡ豸ߵǰûҵ豸.");
					break;
				}		
				CloseHandle(CreateThread(NULL,0,ISPFlashVerifyThread_CH55xUSB,(PVOID)Sel,0,&ThreadID)); //ʼ
				break;
			}
		case IDC_Download: //ع̼
			{
				DWORD ThreadID,Sel;
				Sel = SendDlgItemMessage(hWnd,IDC_DeviceList,CB_GETCURSEL,0,0);
				if( Sel == CB_ERR )
				{
					MessageBox(AfxMainHwnd,"ѡ豸ߵǰûҵ豸","WCH55xDLL DEMO",MB_ICONERROR);
					DbgPrint("ѡ豸ߵǰûҵ豸.");
					break;
				}		
				CloseHandle(CreateThread(NULL,0,ISPFlashDnThread_CH55xUSB,(PVOID)Sel,0,&ThreadID)); //ʼ
			}
			
			break;		
		case IDC_DeviceList: //豸б仯
			if( (wmEvent == CBN_SELCHANGE) || (wmEvent == CBN_SETFOCUS) ) //½ӿ豸б
			{
				CHAR FmtStr[128] ="";
				ULONG i;
				
				i = SendDlgItemMessage(hWnd,IDC_DeviceList,CB_GETCURSEL,0,0);
				if( i == CB_ERR )
					break;
				sprintf(FmtStr,"UID:%02X-%02X-%02X-%02X-%02X-%02X-%02X-%02X,BTVER:%X%X.%X%X",
					AfxDnDev[i].IspMcuUID[0],AfxDnDev[i].IspMcuUID[1],AfxDnDev[i].IspMcuUID[2],
					AfxDnDev[i].IspMcuUID[3],AfxDnDev[i].IspMcuUID[4],AfxDnDev[i].IspMcuUID[5],
					AfxDnDev[i].IspMcuUID[6],AfxDnDev[i].IspMcuUID[7],
					AfxDnDev[i].IspVer[0],AfxDnDev[i].IspVer[1],AfxDnDev[i].IspVer[2],AfxDnDev[i].IspVer[3]); //BOOT 汾
				
				SetDlgItemText(AfxMainHwnd,IDC_DnDevInfor,FmtStr);
				
				if( AfxIspOption.IspInterface == 1 )//ʱ¼ϴδڵѡ
					LastSerPortSel = i;
			}
			break;
		case IDC_SelectIapFile: //ѡļ			
			{// ȡҪ͵ļ		
				CHAR FmtStr[256] = "",FileName[512] = "";
				OPENFILENAME mOpenFile={0};					
				
				sprintf(FmtStr,"ѡIAPļ");			
				// Fill in the OPENFILENAME structure to support a template and hook.
				mOpenFile.lStructSize = sizeof(OPENFILENAME);
				mOpenFile.hwndOwner         = AfxMainHwnd;
				mOpenFile.hInstance         = AfxMainIns;		
				mOpenFile.lpstrFilter       = "*.HEX\0*.HEX\0*.BIN\0*.BIN\0";		
				mOpenFile.lpstrCustomFilter = NULL;
				mOpenFile.nMaxCustFilter    = 0;
				mOpenFile.nFilterIndex      = 0;
				mOpenFile.lpstrFile         = FileName;
				mOpenFile.nMaxFile          = sizeof(FileName);
				mOpenFile.lpstrFileTitle    = NULL;
				mOpenFile.nMaxFileTitle     = 0;
				mOpenFile.lpstrInitialDir   = NULL;
				mOpenFile.lpstrTitle        = FmtStr;
				
				mOpenFile.nFileOffset       = 0;
				mOpenFile.nFileExtension    = 0;
				mOpenFile.lpstrDefExt       = NULL;
				mOpenFile.lCustData         = 0;
				mOpenFile.lpfnHook 		    = NULL;
				mOpenFile.lpTemplateName    = NULL;
				mOpenFile.Flags             = OFN_SHOWHELP | OFN_EXPLORER | OFN_READONLY | OFN_FILEMUSTEXIST;
				if (!GetOpenFileName(&mOpenFile))
				{ 			
					DbgPrint("ѡIAPļ");				
				}
				else
				{
					SetDlgItemText(AfxMainHwnd,IDC_IapDnFile,FileName); //ļ
					SendDlgItemMessage(AfxMainHwnd,IDC_DownloadFile,EM_SETSEL,0xFFFFFFFE,0xFFFFFFFE);//Ƶıĩβ
				}
			}
			break;
		case IDC_SelectUserDnFile: //ѡļ			
			{// ȡҪ͵ļ		
				CHAR FmtStr[256] = "",FileName[512] = "";
				OPENFILENAME mOpenFile={0};					
				
				sprintf(FmtStr,"ѡûļ");			
				// Fill in the OPENFILENAME structure to support a template and hook.
				mOpenFile.lStructSize = sizeof(OPENFILENAME);
				mOpenFile.hwndOwner         = AfxMainHwnd;
				mOpenFile.hInstance         = AfxMainIns;		
				mOpenFile.lpstrFilter       = "*.HEX\0*.HEX\0*.BIN\0*.BIN\0";		
				mOpenFile.lpstrCustomFilter = NULL;
				mOpenFile.nMaxCustFilter    = 0;
				mOpenFile.nFilterIndex      = 0;
				mOpenFile.lpstrFile         = FileName;
				mOpenFile.nMaxFile          = sizeof(FileName);
				mOpenFile.lpstrFileTitle    = NULL;
				mOpenFile.nMaxFileTitle     = 0;
				mOpenFile.lpstrInitialDir   = NULL;
				mOpenFile.lpstrTitle        = FmtStr;
				
				mOpenFile.nFileOffset       = 0;
				mOpenFile.nFileExtension    = 0;
				mOpenFile.lpstrDefExt       = NULL;
				mOpenFile.lCustData         = 0;
				mOpenFile.lpfnHook 		    = NULL;
				mOpenFile.lpTemplateName    = NULL;
				mOpenFile.Flags             = OFN_SHOWHELP | OFN_EXPLORER | OFN_READONLY | OFN_FILEMUSTEXIST;
				if (!GetOpenFileName(&mOpenFile))
				{ 			
					DbgPrint("ѡûļ");				
				}
				else
				{
					SetDlgItemText(AfxMainHwnd,IDC_UserDnFile,FileName); //ļ
					SendDlgItemMessage(AfxMainHwnd,IDC_UserDnFile,EM_SETSEL,0xFFFFFFFE,0xFFFFFFFE);//Ƶıĩβ
				}
			}
			break;
		case IDC_ClearResult: //սϢ
			AfxIspDnCnt = 0;
			AfxIspDnSuccCnt = 0;
			AfxIspDnErrCnt = 0;
			SetDlgItemText(AfxMainHwnd,IDC_ResultShow,"");
			SetDlgItemText(AfxMainHwnd,IDC_DnRecordShow,":0, ɹ:0, ʧ:0");
			break;			
		case WM_DESTROY:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;		
		case WM_DESTROY:
			PostQuitMessage(0);
			break;		
	}
	return 0;
}